SystemOrganization addCategory: #'CodeSight-Tests'!
SystemOrganization addCategory: #'CodeSight-Tracer'!
SystemOrganization addCategory: #'CodeSight-TraceBrowser'!
SystemOrganization addCategory: #'CodeSight-TestTracer'!
SystemOrganization addCategory: #'CodeSight-Browser'!
SystemOrganization addCategory: #'CodeSight-Analyzing'!
SystemOrganization addCategory: #CodeSight!

!OBEnhancementDefinitionPanel methodsFor: '*CodeSight-override' stamp: 'bs 9/24/2009 08:03'!
accept: aText notifying: aController
	| result |
	CSTestRunner sourceCodeAccessMonitor critical: [
		result := super accept: aText notifying: aController ].
	^ result.! !

!Behavior methodsFor: '*CodeSight' stamp: 'bs 10/28/2009 10:03'!
addOverridersOf: aSelector to: aCollection
	self allSubclassesDo: [:subclass | 
		(subclass includesSelector: aSelector)
			ifTrue: [aCollection add: subclass]
			ifFalse: [subclass addOverridersOf: aSelector to: aCollection]]! !

OBBrowser subclass: #CSTraceBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-TraceBrowser'!

!CSTraceBrowser class methodsFor: 'configuration' stamp: 'mp 2/8/2009 18:12'!
defaultMetaNode
	
	| start nextCalls |
	start := OBMetaNode named: 'Traces'.
	nextCalls := OBMetaNode named: 'Next Calls'.
	
	start
		childAt: #traces put: start;
		childAt: #nextCalls put: nextCalls.
	
	nextCalls
		childAt: #nextCalls put: nextCalls.
	
	^ start! !

!CSTraceBrowser class methodsFor: 'configuration' stamp: 'mp 2/8/2009 17:23'!
defaultRootNode
	
	^ CSTraceStartNode new! !

!CSTraceBrowser class methodsFor: 'configuration' stamp: 'mp 2/8/2009 18:47'!
title

	^ 'Trace Browser'! !

!CompiledMethod methodsFor: '*CodeSight' stamp: 'rkrk 10/6/2009 14:35'!
called: aCompiledMethod inDepth: aNumber

	| statistic |
	self flag: #rkrk. "for benchmarking"
	self pvtCodeSightMonitor critical: [
		
		aCompiledMethod privateAddCoveringTestMethod: self.
		
		statistic := self pvtCoveredMethodsStatistics 
			at: aCompiledMethod
			ifAbsentPut: [ CSTestStatistic new ].
		statistic addCallInDepth: aNumber.
			
		self doForEachCoveredMethod valueWithArguments: {  self. aCompiledMethod  } ]! !

!CompiledMethod methodsFor: '*CodeSight' stamp: 'bs 10/16/2009 09:35'!
called: aCompiledMethod inDepth: aNumber receiver: anObject 
	| statistic |
	self pvtCodeSightMonitor critical: [
		aCompiledMethod privateAddCoveringTestMethod: self.
		
		statistic := self pvtCoveredMethodsStatistics 
			at: aCompiledMethod
			ifAbsentPut: [ CSTestStatistic new ].
		statistic 
			addCallInDepth: aNumber
			receiver: anObject.
			
		self pvtDoForEachCoveredMethod valueWithArguments: {  self. aCompiledMethod  } ]! !

!CompiledMethod methodsFor: '*CodeSight' stamp: 'bs 9/24/2009 08:04'!
coveredMethods
	| result |
	self pvtCodeSightMonitor critical: 
		[ result := self pvtCoveredMethodsStatistics keys ].
	^ result! !

!CompiledMethod methodsFor: '*CodeSight' stamp: 'bs 9/24/2009 08:04'!
coveredMethodsStatistics
	| result |
	self pvtCodeSightMonitor critical: 
		[ result := self pvtCoveredMethodsStatistics copy ].
	^ result! !

!CompiledMethod methodsFor: '*CodeSight' stamp: 'bs 9/24/2009 08:04'!
coveringAndNotFixedTestMethods
	| result |
	self pvtCodeSightMonitor critical: [
		result := self pvtCoveringTestMethods copy.
		"fixed link might be established and coverage not yet"
		result removeAllFoundIn: self pvtFixedTestMethods ].
	^ result ! !

!CompiledMethod methodsFor: '*CodeSight' stamp: 'bs 9/24/2009 08:04'!
coveringTestMethods
	| result |
	self pvtCodeSightMonitor critical: [ 
		result := self pvtCoveringTestMethods copy ].
	^ result! !

!CompiledMethod methodsFor: '*CodeSight' stamp: 'bs 10/16/2009 10:07'!
coveringTestMethodsWhenReceiverWasOfKind: aClass 
	| result |
	self pvtCodeSightMonitor critical: [ 
		result := self pvtCoveringTestMethods 
			select: [ :testMethod | 
				(testMethod privateStatisticsForCoveredMethod: self) 
					receiverClasses includes: aClass ] ].
	^ result! !

!CompiledMethod methodsFor: '*CodeSight' stamp: 'bs 10/16/2009 09:34'!
doForEachCoveredMethod
	| result |
	self pvtCodeSightMonitor critical: [ 
		result := self pvtDoForEachCoveredMethod ].
	^ result! !

!CompiledMethod methodsFor: '*CodeSight' stamp: 'bs 10/16/2009 09:35'!
doForEachCoveredMethod: aBlock
	self pvtCodeSightMonitor critical: [
		self pvtDoForEachCoveredMethod: aBlock ].
	^ aBlock! !

!CompiledMethod methodsFor: '*CodeSight' stamp: 'bs 9/24/2009 08:06'!
fixedTestMethods
	| result |
	self pvtCodeSightMonitor critical: 
		[ result := self pvtFixedTestMethods copy ].
	^ result! !

!CompiledMethod methodsFor: '*CodeSight' stamp: 'bs 9/23/2009 20:05'!
fixes: aCompiledTestMethod 
	self fixesAll: {aCompiledTestMethod}! !

!CompiledMethod methodsFor: '*CodeSight' stamp: 'bs 9/24/2009 08:06'!
fixesAll: compiledTestMethods 
	self pvtCodeSightMonitor critical: [
		self pvtFixedTestMethods addAll: compiledTestMethods ]! !

!CompiledMethod methodsFor: '*CodeSight' stamp: 'bs 9/24/2009 08:06'!
hasCoveringTestMethods
	| result |
	self pvtCodeSightMonitor critical: [ 
		result := self pvtCoveringTestMethods isEmpty not ].
	^ result! !

!CompiledMethod methodsFor: '*CodeSight' stamp: 'bs 9/24/2009 08:06'!
hasFixedTestMethods
	| result |
	self pvtCodeSightMonitor critical: [
		result := self pvtFixedTestMethods isEmpty not ].
	^ result! !

!CompiledMethod methodsFor: '*CodeSight' stamp: 'test 9/20/2009 14:24'!
newTestCase
	self assert: [self methodClass inheritsFrom: TestCase].
	self assert: [self selector isTestSelector].
	
	^ self methodClass selector: self selector.! !

!CompiledMethod methodsFor: '*CodeSight' stamp: 'test 9/20/2009 14:43'!
overriddenAndOverridingMethods
	^ self overridingMethods copy add: self overriddenMethod! !

!CompiledMethod methodsFor: '*CodeSight' stamp: 'test 9/20/2009 21:39'!
overriddenAndOverridingMethodsIn: aClass
	|result|
	result := (self overridingMethodsIn: aClass) copy.
	(self overriddenMethodIn: aClass) 
		ifNotNilDo: [:aMethod | result add: aMethod].
	^ result! !

!CompiledMethod methodsFor: '*CodeSight' stamp: 'test 9/20/2009 21:34'!
overriddenMethod
	^ self overriddenMethodIn: self methodClass! !

!CompiledMethod methodsFor: '*CodeSight' stamp: 'test 9/20/2009 21:49'!
overriddenMethodIn: aClass
	^ (aClass superclass whichClassIncludesSelector: self selector)
			ifNotNilDo: [ :superclass | (superclass >> self selector) clientMethod ]
			ifNil: [ nil ].! !

!CompiledMethod methodsFor: '*CodeSight' stamp: 'test 9/20/2009 21:34'!
overridingMethods
	^ self overridingMethodsIn: self methodClass! !

!CompiledMethod methodsFor: '*CodeSight' stamp: 'test 9/21/2009 21:01'!
overridingMethodsIn: aClass
	| overriders |
	overriders := Set new.
	aClass addOverridersOf: self selector to: overriders.
	
	^ overriders collect: [ :overrider | 
			(overrider >> self selector) clientMethod ]! !

!CompiledMethod methodsFor: '*CodeSight' stamp: 'bs 9/23/2009 20:38'!
privateAddCoveringTestMethod: aCompiledTestMethod
	^ self pvtCoveringTestMethods add: aCompiledTestMethod! !

!CompiledMethod methodsFor: '*CodeSight' stamp: 'bs 10/16/2009 10:09'!
privateRemoveCoveredMethod: aCompiledAppMethod
	self pvtCodeSightMonitor critical: [
		self pvtCoveredMethodsStatistics removeKey: aCompiledAppMethod ]! !

!CompiledMethod methodsFor: '*CodeSight' stamp: 'bs 10/16/2009 10:08'!
privateRemoveCoveringTestMethod: aTestCaseMethod
	self pvtCodeSightMonitor critical: [
		"the other direction is removed by the sender"
		self pvtCoveringTestMethods remove: aTestCaseMethod ifAbsent: [] ]
	! !

!CompiledMethod methodsFor: '*CodeSight' stamp: 'bs 10/16/2009 10:06'!
privateStatisticsForCoveredMethod: aCompiledMethod 
	^ self pvtCoveredMethodsStatistics at: aCompiledMethod ! !

!CompiledMethod methodsFor: '*CodeSight' stamp: 'bs 9/23/2009 18:53'!
pvtCodeSightMonitor
	^ self properties 
		at: #codeSightMonitor
		ifAbsentPut: [ Monitor new ]! !

!CompiledMethod methodsFor: '*CodeSight' stamp: 'bs 9/23/2009 18:13'!
pvtCoveredMethodsStatistics
	^ self properties 
			at: #codeSightStatistics
			ifAbsentPut: [ IdentityDictionary new ]! !

!CompiledMethod methodsFor: '*CodeSight' stamp: 'bs 9/23/2009 18:10'!
pvtCoveringTestMethods
	^ self properties at: #codeSightCovering ifAbsentPut: [ IdentitySet new ]! !

!CompiledMethod methodsFor: '*CodeSight' stamp: 'bs 10/16/2009 09:33'!
pvtDoForEachCoveredMethod
	| |
	self assert: [ self selector isTestSelector ].
	^ self properties 
			at: #codeSightDoForEachCoveredMethod
			ifAbsentPut: [ [ :aTestMethod :anAppMethod |  ] ]! !

!CompiledMethod methodsFor: '*CodeSight' stamp: 'bs 10/16/2009 09:34'!
pvtDoForEachCoveredMethod: aBlock
	self assert: [ self selector isTestSelector ].
	self pvtCodeSightMonitor critical: [
		self properties at: #codeSightDoForEachCoveredMethod put: aBlock ].
	^ aBlock! !

!CompiledMethod methodsFor: '*CodeSight' stamp: 'bs 9/23/2009 18:30'!
pvtFixedTestMethods
	^ self properties at: #codeSightFixed ifAbsentPut: [ IdentitySet new ]! !

!CompiledMethod methodsFor: '*CodeSight' stamp: 'bs 9/23/2009 18:35'!
pvtRemoveCoveredMethod: aCompiledAppMethod
	self pvtCoveredMethodsStatistics removeKey: aCompiledAppMethod! !

!CompiledMethod methodsFor: '*CodeSight' stamp: 'bs 9/23/2009 18:37'!
pvtRemoveCoveringTestMethod: aTestCaseMethod
	"the other direction is removed by the sender"
	self pvtCoveringTestMethods remove: aTestCaseMethod! !

!CompiledMethod methodsFor: '*CodeSight' stamp: 'bs 10/16/2009 10:10'!
removeCoveredMethod: aCompiledAppMethod
	self pvtCodeSightMonitor critical: [
		self privateRemoveCoveredMethod: aCompiledAppMethod ]! !

!CompiledMethod methodsFor: '*CodeSight' stamp: 'bs 10/16/2009 10:09'!
removeCoveringTestMethod: aTestCaseMethod
	self pvtCodeSightMonitor critical: [
		"the other direction is removed by the sender"
		self privateRemoveCoveringTestMethod: aTestCaseMethod ]
	! !

!CompiledMethod methodsFor: '*CodeSight' stamp: 'bs 9/24/2009 08:07'!
removeFixedTestMethodIfNotCoveringAnymore: aTestCaseMethod
	self pvtCodeSightMonitor critical: [
		(self pvtFixedTestMethods includes: aTestCaseMethod) ifFalse: [^ self].
		(self pvtCoveringTestMethods includes: aTestCaseMethod) ifTrue: [^ self].
		self pvtFixedTestMethods remove: aTestCaseMethod ]
	! !

!CompiledMethod methodsFor: '*CodeSight' stamp: 'bs 9/23/2009 21:17'!
resetAllCoverageData
	self 
		resetCoveringTestMethods;
		resetCoveredMethodsStatistics;
		resetFixedTestMethods;
		resetDoForEachCoveredMethod.! !

!CompiledMethod methodsFor: '*CodeSight' stamp: 'bs 10/16/2009 10:09'!
resetCoveredMethodsStatistics
	| result |
	self pvtCodeSightMonitor critical: [
		self pvtCoveredMethodsStatistics keysDo: [ :coveredMethod | 
				coveredMethod privateRemoveCoveringTestMethod: self. ].
	
		result := self properties 
			removeKey: #codeSightStatistics 
			ifAbsent: [ ] ].
	^ result! !

!CompiledMethod methodsFor: '*CodeSight' stamp: 'bs 10/16/2009 10:10'!
resetCoveringTestMethods
	self pvtCodeSightMonitor critical: [
		self pvtCoveringTestMethods do: [:testMethod |
			testMethod privateRemoveCoveredMethod: self.
			self pvtRemoveCoveringTestMethod: testMethod. ] ].
	! !

!CompiledMethod methodsFor: '*CodeSight' stamp: 'bs 9/24/2009 08:08'!
resetDoForEachCoveredMethod
	self pvtCodeSightMonitor critical: [ 
		self properties removeKey: #codeSightDoForEachCoveredMethod ifAbsent: [] ].! !

!CompiledMethod methodsFor: '*CodeSight' stamp: 'bs 9/24/2009 08:08'!
resetFixedTestMethods
	self pvtCodeSightMonitor critical: [
		self pvtFixedTestMethods removeAll: (self pvtFixedTestMethods) ].! !

!CompiledMethod methodsFor: '*CodeSight' stamp: 'bs 10/16/2009 10:07'!
statisticsForCoveredMethod: aCompiledMethod 
	| result |
	self pvtCodeSightMonitor critical: [
		result := self privateStatisticsForCoveredMethod: aCompiledMethod  ].
	^ result! !

OBEnhancementMetagraphBuilder subclass: #CSMetagraphBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Browser'!

!CSMetagraphBuilder methodsFor: 'as yet unclassified' stamp: 'bs 5/2/2009 23:41'!
createMethodMetaNode
	| methodMetaNode testMetaNode |
	testMetaNode := OBEnhancementMetaNode named: #CoveringTestCases.
	methodMetaNode := OBEnhancementMetaNode named: #Method.
	methodMetaNode childAt: #coveringTestMethods put: testMetaNode.
	^ methodMetaNode! !

!CSMetagraphBuilder methodsFor: 'as yet unclassified' stamp: 'bs 5/3/2009 09:57'!
methodMetaNode
   ^(self metaNodes
		at: #Method
		ifAbsentPut: [OBEnhancementMetaNode named: #Method])! !

!CSMetagraphBuilder methodsFor: 'as yet unclassified' stamp: 'bs 5/3/2009 10:00'!
populateMethodNode
	| testMetaNode |
	super populateMethodNode.
	testMetaNode := OBEnhancementMetaNode named: #CoveringTestCases.
	self methodMetaNode
		childAt: #coveringTestMethods put: testMetaNode.
! !

TestCase subclass: #CSAsyncAutoRunTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Tests'!

!CSAsyncAutoRunTests methodsFor: 'as yet unclassified' stamp: 'bs 9/13/2009 14:55'!
testForOnlyOneTestRunnerInTddAutoRunMode
	| runner1 runner2 runner3 |
	runner1 := CSTestRunner new.
	runner2 := CSTestRunner new.
	runner3 := CSTestRunner new.
	
	[runner1 tddAutoRunStart.
	self should: [runner1 isInTddAutoRunMode].
	self shouldnt: [runner2 isInTddAutoRunMode].
	self shouldnt: [runner3 isInTddAutoRunMode].
	
	runner2 tddAutoRunStart.
	self shouldnt: [runner1 isInTddAutoRunMode].
	self should: [runner2 isInTddAutoRunMode].
	self shouldnt: [runner3 isInTddAutoRunMode].
	
	runner3 tddAutoRunStart.
	self shouldnt: [runner1 isInTddAutoRunMode].
	self shouldnt: [runner2 isInTddAutoRunMode].
	self should: [runner3 isInTddAutoRunMode].
	
	runner3 tddAutoRunStop.
	self shouldnt: [runner1 isInTddAutoRunMode].
	self should: [runner2 isInTddAutoRunMode].
	self shouldnt: [runner3 isInTddAutoRunMode].
	
	runner2 tddAutoRunStop.
	self should: [runner1 isInTddAutoRunMode].
	self shouldnt: [runner2 isInTddAutoRunMode].
	self shouldnt: [runner3 isInTddAutoRunMode]. 
	
	runner1 tddAutoRunStop.
	self shouldnt: [runner1 isInTddAutoRunMode].
	self shouldnt: [runner2 isInTddAutoRunMode].
	self shouldnt: [runner3 isInTddAutoRunMode].
	]
	ensure: [
		runner1 tddAutoRunStop.
		runner2 tddAutoRunStop.
		runner3 tddAutoRunStop.
		]! !

!CSAsyncAutoRunTests methodsFor: 'as yet unclassified' stamp: 'bs 10/7/2009 11:14'!
testRunInBackground
	| testRunner |
	CSAsyncExampleTest resetCollectedMessages.
	self should: [ CSAsyncExampleTest collectedMessagesAsString = '' ].
	
	testRunner := CSTestRunner new.
	testRunner runSuite: CSAsyncExampleTest exampleSuite.
	self should: [ CSAsyncExampleTest collectedMessagesAsString = 'Hello' ].
	
	CSAsyncExampleTest resetCollectedMessages.
	testRunner enableRunningTestsInBackground.
	testRunner runSuite: CSAsyncExampleTest backgroundExampleSuite.
	(Delay forMilliseconds: 100) wait.
	CSTestRunner sourceCodeAccessMonitor critical: [ 
		CSAsyncExampleTest addMessage: 'World'. ].
	self should: [ CSAsyncExampleTest collectedMessagesAsString = 'HelloWorld' ].
	testRunner disableRunningTestsInBackground.! !

!CSAsyncAutoRunTests methodsFor: 'as yet unclassified' stamp: 'bs 9/14/2009 10:39'!
testRunningExampleSuite
	| testRunner |
	CSAsyncExampleTest resetCollectedMessages.
	testRunner := CSTestRunner new.
	testRunner runSuite: (CSAsyncExampleTest exampleSuite).
	self should: [CSAsyncExampleTest collectedMessagesAsString = 'Hello']. ! !

TestCase subclass: #CSAsyncExampleTest
	instanceVariableNames: ''
	classVariableNames: 'CollectedMessages'
	poolDictionaries: ''
	category: 'CodeSight-Tests'!

!CSAsyncExampleTest class methodsFor: 'as yet unclassified' stamp: 'bs 9/13/2009 14:07'!
addMessage: aString
	self collectedMessages add: aString.! !

!CSAsyncExampleTest class methodsFor: 'as yet unclassified' stamp: 'bs 9/14/2009 10:43'!
backgroundExampleSuite
	| aSuite |
	aSuite := TestSuite new.
	aSuite addTest: (self selector: #testRunExampleInBackground).
	^ aSuite.! !

!CSAsyncExampleTest class methodsFor: 'as yet unclassified' stamp: 'bs 9/13/2009 14:02'!
collectedMessages
	^ CollectedMessages ifNil: [CollectedMessages := OrderedCollection new.]! !

!CSAsyncExampleTest class methodsFor: 'as yet unclassified' stamp: 'bs 9/13/2009 14:05'!
collectedMessagesAsString
	| stream |
	stream := WriteStream with: String new.
	self collectedMessages do: [: elem | stream nextPutAll: elem].
	^ stream contents! !

!CSAsyncExampleTest class methodsFor: 'as yet unclassified' stamp: 'bs 9/14/2009 10:39'!
exampleSuite
	| aSuite |
	aSuite := TestSuite new.
	aSuite addTest: (self selector: #testExample).
	^ aSuite.! !

!CSAsyncExampleTest class methodsFor: 'as yet unclassified' stamp: 'bs 9/13/2009 14:03'!
resetCollectedMessages
	CollectedMessages := nil.! !

!CSAsyncExampleTest methodsFor: 'as yet unclassified' stamp: 'bs 9/14/2009 10:36'!
testExample
	self class addMessage: 'Hello'! !

!CSAsyncExampleTest methodsFor: 'as yet unclassified' stamp: 'bs 9/14/2009 16:25'!
testRunExampleInBackground
	| testRunner |
	testRunner := CSTestRunner new.
	testRunner enableRunningTestsInBackground.
	testRunner runSuite: (CSAsyncExampleTest exampleSuite).! !

TestCase subclass: #CSBenchmarkTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Tests'!

!CSBenchmarkTest class methodsFor: 'as yet unclassified' stamp: 'bs 10/11/2009 22:12'!
wantsRecompilationProgressReported
	"turn off for this clas because it is modified during tests"

	^ false
! !

!CSBenchmarkTest methodsFor: 'as yet unclassified' stamp: 'bs 10/11/2009 22:12'!
testFirstnameAccessors
	
	| aPerson aName |
	aPerson := CSExamplePerson new.
	aName := 'Bastian'.
	aPerson firstname: aName.
	self assert: aPerson firstname = aName.! !

TestCase subclass: #CSExampleFooBarTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Tests'!

!CSExampleFooBarTest methodsFor: 'as yet unclassified' stamp: 'bs 9/24/2009 08:11'!
testFooBar
	CSExampleFooBar new fooBar! !

TestCase subclass: #CSExampleTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Tests'!

!CSExampleTest class methodsFor: 'as yet unclassified' stamp: 'bs 9/23/2009 20:42'!
wantsRecompilationProgressReported
	"turn off for this clas because it is modified during tests"

	^ false
! !

!CSExampleTest methodsFor: 'as yet unclassified' stamp: 'mab 3/25/2009 16:15'!
testFailing
	self assert: false.
	! !

!CSExampleTest methodsFor: 'as yet unclassified' stamp: 'test 10/28/2009 11:49'!
testFirstnameAccessors
	
	| aPerson aName |
	aPerson := CSExamplePerson new.
	aName := 'Bastian'.
	aPerson firstname: aName.
	self assert: aPerson firstname = aName.! !

TestCase subclass: #CSTestBase
	instanceVariableNames: 'tddAutoRunTestRunner registeredClasses removedMethods installedMethods createdClasses undoInTearDown registeredPackages unregisteredPackages'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Tests'!

CSTestBase subclass: #CSAutoTddTestBase
	instanceVariableNames: 'testRunner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Tests'!

!CSAutoTddTestBase methodsFor: 'as yet unclassified' stamp: 'test 9/21/2009 08:52'!
createExamplePersonSubclass
	| aClass |
	aClass := CSExamplePerson subclass: #CSExamplePersonSubclass
							instanceVariableNames: ''
							classVariableNames: ''
							poolDictionaries: ''
							category: 'CodeSight-Tests'.
	self undoInTearDown ifTrue: [
		self createdClasses add: aClass].
	^ aClass! !

!CSAutoTddTestBase methodsFor: 'as yet unclassified' stamp: 'test 9/21/2009 19:51'!
createSuperCallTestCode
	^ 'testSuperCall', String crlf, String tab, 'CSExamplePersonSubclass new asString'.! !

!CSAutoTddTestBase methodsFor: 'as yet unclassified' stamp: 'bs 10/7/2009 10:09'!
setUp
	super setUp.
	testRunner := CSTestRunner new.
	testRunner tddAutoRunStart.! !

!CSAutoTddTestBase methodsFor: 'as yet unclassified' stamp: 'bs 10/7/2009 10:09'!
tearDown
	testRunner tddAutoRunStop.
	testRunner disableRunningTestsInBackground.
	testRunner := nil.
	super tearDown.! !

CSAutoTddTestBase subclass: #CSFixturesTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Tests'!

!CSFixturesTest methodsFor: 'as yet unclassified' stamp: 'bs 9/23/2009 20:11'!
testAdditionOfOverridingMethod
	| personsubclass selector method superCallTestSelector superCallTestMethod |
	selector := #asString.
	method := (CSExamplePerson >> selector) clientMethod.
	method 
		resetCoveringTestMethods;
		resetFixedTestMethods.
	
	self undoInTearDownDo: [
		personsubclass := self createExamplePersonSubclass.
		self traceClass: personsubclass.
		self traceClass: CSExamplePerson.
		
		superCallTestSelector := self installMethod: self createSuperCallTestCode 
												inClass: CSExampleTest ].
	
	superCallTestMethod := (CSExampleTest >> superCallTestSelector).
	superCallTestMethod called: method inDepth: 1 receiver: nil.
	method fixes: superCallTestMethod.
	self should: [ method hasFixedTestMethods ].
		
	personsubclass compile: (CSExamplePerson sourceCodeAt: selector).
	self shouldnt: [ testRunner result passed size = 0 ].
	self should: [ (personsubclass >> selector) hasCoveringTestMethods  ].
	self should: [ (personsubclass >> selector) hasFixedTestMethods  ].! !

!CSFixturesTest methodsFor: 'as yet unclassified' stamp: 'test 9/21/2009 09:30'!
testEstablishingFixedRelationship
	|methodSelector method methodSource|
	methodSelector := #firstname.
	methodSource := CSExamplePerson sourceCodeAt: methodSelector.
	method := CSExamplePerson >> methodSelector.
	method 
		resetCoveringTestMethods;
		resetFixedTestMethods.
	
	"specify class explicitly, #methodClass does not work on getter methods"

	self undoInTearDownDo: [
		self removeMethod: method inClass: CSExamplePerson.
		self traceClass: CSExamplePerson].
	
	testRunner runSuite: CSExampleTest suite.
	
	CSExamplePerson compile: methodSource. 
	self should: [ (CSExamplePerson >> methodSelector) hasCoveringTestMethods ].
	self should: [ (CSExamplePerson >> methodSelector) hasFixedTestMethods ].! !

!CSFixturesTest methodsFor: 'as yet unclassified' stamp: 'bs 9/23/2009 21:47'!
testFixedTestMethods
	| testMethod appMethod |
	appMethod := (CSExamplePerson >> #firstname) clientMethod.
	testMethod := (CSExampleTest >> #testFirstnameAccessors) clientMethod.
	
	appMethod fixes: testMethod. 
	self should: [ appMethod fixedTestMethods size = 1 ].
	appMethod resetFixedTestMethods.	
	self should: [ appMethod fixedTestMethods size = 0 ].! !

!CSFixturesTest methodsFor: 'as yet unclassified' stamp: 'bs 9/23/2009 21:54'!
testFixesInDoForEachBlock
	| testMethod appMethod |
	appMethod := (CSExamplePerson >> #firstname) clientMethod.
	testMethod := (CSExampleTest >> #testFirstnameAccessors) clientMethod.
	appMethod resetAllCoverageData.
	testMethod resetAllCoverageData.
	
	testMethod doForEachCoveredMethod: [:blockTestMethod :blockAppMethod |
		blockAppMethod fixes: blockTestMethod ].
	
	testMethod called: appMethod inDepth: 1 receiver: nil.
	self should: [ appMethod coveringTestMethods size = 1 ].
	self should: [ appMethod fixedTestMethods size = 1 ].
	
	appMethod resetAllCoverageData.
	testMethod resetAllCoverageData.! !

!CSFixturesTest methodsFor: 'as yet unclassified' stamp: 'bs 10/6/2009 12:10'!
testRecompiling
	| testMethod |
	testMethod := (CSExampleTest >> #testFirstnameAccessors) clientMethod.
	
	(CSExamplePerson >> #firstname) fixes: testMethod.
	self should: [ (CSExamplePerson >> #firstname) fixedTestMethods size = 1 ].
	CSExamplePerson compile: (CSExamplePerson sourceCodeAt: #firstname).
	self should: [ (CSExamplePerson >> #firstname) fixedTestMethods size = 1 ].! !

!CSFixturesTest methodsFor: 'as yet unclassified' stamp: 'bs 9/23/2009 20:10'!
testRefactoring
	| personsubclass selector method superCallTestSelector subMethod |
	selector := #asString.
	method := (CSExamplePerson >> selector) clientMethod.
	method 
		resetCoveringTestMethods;
		resetFixedTestMethods.
	
	self undoInTearDownDo: [
		personsubclass := self createExamplePersonSubclass.
		self traceClass: personsubclass.
		self traceClass: CSExamplePerson.
		
		superCallTestSelector := self installMethod: self createSuperCallTestCode 
												inClass: CSExampleTest ].
	
	testRunner reset.
	personsubclass compile: selector asString.
	self should: [ testRunner result passed size = 1 ].
	
	subMethod := (personsubclass >> selector) clientMethod.
	self should: [ subMethod hasCoveringTestMethods ].
	subMethod fixes: (CSExampleTest >> superCallTestSelector).
	self should: [ subMethod hasFixedTestMethods ].
	
	testRunner reset.
	personsubclass compile: (CSExamplePerson sourceCodeAt: selector).
	self should: [ testRunner result passed size = 1 ].
	self should: [ (CSExamplePerson >> selector) hasCoveringTestMethods ].
	self should: [ (CSExamplePerson >> selector) hasFixedTestMethods ].
	
	testRunner reset.
	personsubclass compile: selector asString.
	self should: [ testRunner result passed size = 1 ].
	self shouldnt: [ (CSExamplePerson >> selector) hasFixedTestMethods ].! !

!CSFixturesTest methodsFor: 'as yet unclassified' stamp: 'bs 9/23/2009 20:10'!
testRemoveOfOverriddenMethod
	| personsubclass selector method superCallTestSelector |
	selector := #asString.
	method := (CSExamplePerson >> selector) clientMethod.
	method 
		resetCoveringTestMethods;
		resetFixedTestMethods.
	
	self undoInTearDownDo: [
		personsubclass := self createExamplePersonSubclass.
		personsubclass compile: (CSExamplePerson sourceCodeAt: selector).
		self traceClass: personsubclass.
		self traceClass: CSExamplePerson.
		
		superCallTestSelector := self installMethod: self createSuperCallTestCode 
												inClass: CSExampleTest ].
	
	method fixes: (CSExampleTest >> superCallTestSelector).
		
	self undoInTearDownDo: [
		self removeMethod: method inClass: CSExamplePerson].	
	
	self should: [ (personsubclass >> selector) hasFixedTestMethods ]! !

CSAutoTddTestBase subclass: #CSTddAutoRunTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Tests'!

!CSTddAutoRunTests methodsFor: 'as yet unclassified' stamp: 'bs 9/10/2009 22:28'!
createFooBarTestClass
	^	TestCase subclass: #CSFooBarTest
					instanceVariableNames: ''
					classVariableNames: ''
					poolDictionaries: ''
					category: 'CodeSight-Tests'! !

!CSTddAutoRunTests methodsFor: 'as yet unclassified' stamp: 'bs 9/11/2009 23:18'!
createSubclassTestCode
	^ 'testFirstnameAccessorsForPersonAndAllSubclasses
			| aPerson aName |
			CSExamplePerson withAllSubclassesDo: [:aPersonClass | 
			aPerson := aPersonClass new.
			aName := #Bastian asString.
			aPerson firstname: aName.
			self assert: aPerson firstname = aName. ]'! !

!CSTddAutoRunTests methodsFor: 'test method events' stamp: 'bs 10/6/2009 18:44'!
testAddAndChangeOfNonTestMethodsInTestClasses
	| selector |
	[	selector := #setUp.
		CSExampleTest compile: selector, String crlf.
		self should: [testRunner result passed isEmpty].
		CSExampleTest compile: selector, String crlf.
		CSExampleTest compile: selector, String crlf.
		self should: [testRunner result passed isEmpty]]
	ensure: [
		(CSExampleTest includesSelector: selector) 
			ifTrue: [CSExampleTest removeSelector: selector]].
	! !

!CSTddAutoRunTests methodsFor: 'test method events' stamp: 'bs 10/6/2009 16:48'!
testAdditionAndRemovalOfOverriddenMethod
	| methodSelector methodSource personsubclass superCallTestSelector |
	CSExamplePerson methodsDo: [ :method | 
		method 
			resetCoveringTestMethods;
			resetFixedTestMethods. ].
	
	methodSelector := #asString.
	methodSource := CSExamplePerson sourceCodeAt: methodSelector.
	
	self undoInTearDownDo: [
		personsubclass := self createExamplePersonSubclass.
		personsubclass compile: methodSource.
		superCallTestSelector := self installMethod: self createSuperCallTestCode inClass: CSExampleTest.
		
		self traceClass: CSExamplePerson.
		self traceClass: personsubclass ].
	
	Transcript cr; show: 'test1'.
	testRunner reset; runSuite: CSExampleTest suite.
	Transcript cr; show: 'test2'.
	self shouldnt: [ (CSExamplePerson >> methodSelector) coveringTestMethods isEmpty ].
	self shouldnt: [ (personsubclass >> methodSelector) coveringTestMethods isEmpty ].
		
	testRunner reset.
	self undoInTearDownDo: [
		self removeMethod: (CSExamplePerson >> methodSelector) inClass: CSExamplePerson ].
		
	self should: [ testRunner result passed size = 1 ].
	self shouldnt: [ (personsubclass >> methodSelector) coveringTestMethods isEmpty ].
		
	testRunner reset.
	CSExamplePerson compile: methodSource.
	self should: [ testRunner result passed size = 1].
	self shouldnt: [ (CSExamplePerson >> methodSelector) coveringTestMethods isEmpty ].
	self shouldnt: [ (personsubclass >> methodSelector) coveringTestMethods isEmpty ].! !

!CSTddAutoRunTests methodsFor: 'test method events' stamp: 'test 9/21/2009 22:52'!
testAdditionAndRemovalOfSubclassesWithOverridingMethods
	| selector source subclass subclassTestSelector |
	CSExamplePerson methodsDo: [ :method |
		method 
			resetCoveringTestMethods;
			resetFixedTestMethods ].
	
	selector := #firstname.
	source := CSExamplePerson sourceCodeAt: selector.
	
	self undoInTearDownDo: [
		subclass := self createExamplePersonSubclass.
		self traceClass: CSExamplePerson.
		self traceClass: subclass.
		subclassTestSelector := self installMethod: self createSubclassTestCode 
											  inClass: CSExampleTest ].
	
	testRunner reset; runSuite: CSExampleTest suite.
	self should: [ testRunner result passed size = 2 ].
	self should: [ (CSExamplePerson >> #firstname) coveringTestMethods size = 2 ].
	
	testRunner reset.
	subclass compile: source.
	self should: [ testRunner result passed size = 2 ].
	
	testRunner reset.
	subclass removeSelector: selector.
	self should: [ testRunner result passed size = 1 ].
	
	subclass compile: source.
	testRunner reset.
	subclass removeFromSystem.
	self should: [ testRunner result passed size = 1 ]! !

!CSTddAutoRunTests methodsFor: 'test method events' stamp: 'test 9/21/2009 09:33'!
testCoverageAdaptationAfterTestClassOrMethodRemoved
	| selector testClass testClassName testMethodSelector testMethodSource |
	
	selector := #firstname. 
	testMethodSelector := #testFirstnameAccessors.
	testClass := self createFooBarTestClass.
	testClassName := testClass name.
	testMethodSource := CSExampleTest sourceCodeAt: testMethodSelector.
	CSExamplePerson methodsDo: [:method | 
		method 
			resetCoveringTestMethods;
			resetFixedTestMethods ].
	
	[	CSCoverageTracingWrapper registerClass: CSExamplePerson.	
		testClass compile: testMethodSource.
		self should: [testRunner result passed size = 1].
		self should: [(CSExamplePerson >> selector) coveringTestMethods size = 1].
		
		testClass removeSelector: testMethodSelector.
		self should: [(CSExamplePerson >> selector) coveringTestMethods size = 0].
		
		testClass compile: testMethodSource.
		testClass removeFromSystem.
		self should: [(CSExamplePerson >> selector) coveringTestMethods size = 0]]
	ensure: [
		(CSExampleTest includesSelector: testMethodSelector)
			ifFalse: [CSExampleTest compile: testMethodSource]. 
		(Smalltalk classNamed: testClassName) 
			ifNotNil: [ testClass removeFromSystem ].
		CSCoverageTracingWrapper unregisterClass: CSExamplePerson]
	! !

!CSTddAutoRunTests methodsFor: 'test method events' stamp: 'test 9/21/2009 08:41'!
testDontResetResultIfThereIsNothingToRun
	|source|
	testRunner runSuite: CSExampleTest suite.
	self shouldnt: [testRunner result passed = 0].
	
	source := ('fooBar', String crlf).
	self undoInTearDownDo: [
		self installMethod: source inClass: CSExamplePerson.].
	self shouldnt: [testRunner result passed = 0].! !

!CSTddAutoRunTests methodsFor: 'test method events' stamp: 'bs 9/11/2009 23:52'!
testExecutionOfAddedTestMethod
	| selector source runTestCase|
	selector := #testFirstnameAccessors.
	source := CSExampleTest sourceCodeAt: selector. 
	CSExampleTest removeSelector: selector.
	CSExampleTest compile: source.
	self should: [testRunner result passed isEmpty not].
	runTestCase := testRunner result passed first.
	self should: [runTestCase isKindOf: CSExampleTest].
	self should: [runTestCase selector = selector].! !

!CSTddAutoRunTests methodsFor: 'test method events' stamp: 'bs 9/11/2009 23:52'!
testExecutionOfChangedTestMethod
	| selector runTestCase|
	selector := #testFirstnameAccessors. 
	CSExampleTest compile: (CSExampleTest sourceCodeAt: selector).
	self should: [testRunner result passed isEmpty not].
	runTestCase := testRunner result passed first.
	self should: [runTestCase isKindOf: CSExampleTest].
	self should: [runTestCase selector = selector].! !

!CSTddAutoRunTests methodsFor: 'test method events' stamp: 'bs 9/11/2009 23:52'!
testExecutionOfCoveringTestsAfterMethodChanged

	CSCoverageTracingWrapper registerClass: CSExamplePerson.
	testRunner reset; runSuite: CSExampleTest suite. 
	
	CSExamplePerson compile: (CSExamplePerson sourceCodeAt: #firstname:).
	self should: [testRunner result passed isEmpty not].
	self should: [testRunner result passed first isKindOf: CSExampleTest].
	CSCoverageTracingWrapper unregisterClass: CSExamplePerson.! !

!CSTddAutoRunTests methodsFor: 'test method events' stamp: 'rkrk 9/21/2009 22:33'!
testExecutionOfFailedTestsAfterMethodAddedOrChanged
	| methodSelector appMethodSource method | 
	methodSelector := #firstname.
	appMethodSource := CSExamplePerson sourceCodeAt: methodSelector.
	method := CSExamplePerson >> methodSelector.
	method 
		resetCoveringTestMethods;
		resetFixedTestMethods.
	
	self undoInTearDownDo: [
		self removeMethod: method inClass: CSExamplePerson].
	
	testRunner reset; runSuite: CSExampleTest suite.
	self should: [testRunner result errors isEmpty not].
	self should: [testRunner result errors anySatisfy: [:test | 
		(test isKindOf: CSExampleTest) and: [test selector = #testFirstnameAccessors]]].
	
	CSExamplePerson compile: appMethodSource.
	self should: [testRunner result errors isEmpty].
	self should: [testRunner result passed isEmpty not].
	self should: [testRunner result passed first isKindOf: CSExampleTest].! !

!CSTddAutoRunTests methodsFor: 'test method events' stamp: 'bs 10/6/2009 22:17'!
testForEndlessLoopUsingDoForEachCoveredMethod
	|runner|
	
	runner := CSTestRunner new.
	runner testCasesToRun add: (CSExampleTest selector: #testFirstnameAccessors).
	runner runOpenTestCasesInSuite.
	
	"original version that break a lot of stuff.
	 I assume that using 'self doForEachCoveredMethod' in another doForEach.. Block was not a good idea"
	"CSTestRunner >> #runOpenTestCasesInSuite
	| aSuite testMethod |
	
	aSuite := TestSuite new.
	
	self failedTestCases do: [ :aTestCase |
		aSuite addTest: aTestCase.
		testMethod := aTestCase class >> aTestCase selector.
		testMethod doForEachCoveredMethod: [:aTestMethod :anAppMethod | 
			anAppMethod fixes: aTestMethod.
			self doForEachCoveredMethod valueWithArguments: {aTestMethod. anAppMethod}] ].
	
	
	self testCasesToRun do: [ :aTestCase |
		aSuite addTest: aTestCase.
		testMethod := aTestCase class >> aTestCase selector.
		testMethod doForEachCoveredMethod: [:aTestMethod :anAppMethod | 
			self doForEachCoveredMethod valueWithArguments: {aTestMethod. anAppMethod}]].
	
	self resetTestCasesToRun.
	
	aSuite tests ifNotEmpty: [
		self reset; runSuite: aSuite].
	
	self doForEachCoveredMethod: nil."
	! !

!CSTddAutoRunTests methodsFor: 'test class events' stamp: 'bs 9/11/2009 23:52'!
testModificationOfClass
	|instVarName|
	instVarName := 'foobar'. 
	[	CSCoverageTracingWrapper registerClass: CSExamplePerson.
		testRunner reset; runSuite: CSExampleTest suite.
		self should: [(CSExamplePerson >> #firstname) hasCoveringTestMethods].

		CSExamplePerson addInstVarName: instVarName.
		self should: [(CSExamplePerson >> #firstname) hasCoveringTestMethods]]
	ensure: [
		(CSExamplePerson instVarNames includes: instVarName)
			ifTrue: [CSExamplePerson removeInstVarName: instVarName].
		CSCoverageTracingWrapper unregisterClass: CSExamplePerson]! !

!CSTddAutoRunTests methodsFor: 'test class events' stamp: 'bs 10/28/2009 10:07'!
testModificationTestOfClass
	|instVarName|
	instVarName := 'foobar'.
	[	CSCoverageTracingWrapper registerClass: CSExamplePerson.
		CSExampleTest addInstVarName: instVarName.
		self should: [testRunner result passed size = 1].
		self should: [(CSExamplePerson >> #firstname) hasCoveringTestMethods]]
	ensure: [
		(CSExampleTest instVarNames includes: instVarName)
			ifTrue: [CSExampleTest removeInstVarName: instVarName].
		CSCoverageTracingWrapper unregisterClass: CSExamplePerson]! !

!CSTddAutoRunTests methodsFor: 'test method events' stamp: 'rkrk 9/21/2009 22:33'!
testRemovalOfFailedTestCase
	| selector |
	[	selector := #testFooBar. 
		self class compile: selector, String crlf, String tab, 'self fail.'.
		self should: [testRunner result failures notEmpty].
		self should: [testRunner result failures anySatisfy: [:test | 
			(test isKindOf: self class) and: [test selector = selector]]].
		self class removeSelector: selector.
		self should: [testRunner result failures isEmpty].
		self should: [testRunner result errors isEmpty]] 
	ensure: [
		(self class includesSelector: selector) 
			ifTrue: [self class removeSelector: selector]]! !

!CSTddAutoRunTests methodsFor: 'test method events' stamp: 'bs 9/11/2009 23:52'!
testRemovalOfFailedTestsAfterTestClassOrMethodRemoved
	| testClass fooBarSource testClassName testMethodSelector |
	
	[	testClass := self createFooBarTestClass.
		testClassName := testClass name. 
		fooBarSource := 'testFooBar', String crlf , String tab , 'self fail'.
		
		testMethodSelector := testClass compile: fooBarSource.
		self should: [ testRunner result failures size = 1 ].
		testClass removeSelector: testMethodSelector.
		self should: [ testRunner result failures isEmpty ].
		
		testMethodSelector := testClass compile: fooBarSource.
		self should: [ testRunner result failures size = 1 ].
		testClass removeFromSystem.
		self should: [ testRunner result failures isEmpty ] ] 
	ensure: [ 
		(Smalltalk classNamed: testClassName) 
			ifNotNil: [ testClass removeFromSystem ] ]! !

!CSTddAutoRunTests methodsFor: 'test class events' stamp: 'bs 9/11/2009 23:52'!
testRemovalOfTestClass
	|testClass testClassName|
	[	testClass := self createFooBarTestClass. 
		testClassName := testClass name.
		testClass compile: 'testFooBar', String crlf, String tab, 'self fail'.
		self should: [testRunner result failures size = 1].
		testClass removeFromSystem.
		self should: [testRunner result failures isEmpty]]
	ensure: [
		(Smalltalk classNamed: testClassName) 
			ifNotNil: [testClass removeFromSystem]]! !

!CSTddAutoRunTests methodsFor: 'test class events' stamp: 'bs 9/11/2009 23:52'!
testRenamingOfClass
	|class oldName|
	[	CSCoverageTracingWrapper registerClass: CSExamplePerson.
		testRunner reset; runSuite: CSExampleTest suite. 
		self should: [(CSExamplePerson >> #firstname) hasCoveringTestMethods].
		
		class := CSExamplePerson.
		oldName := class name.
		CSExamplePerson rename: (oldName, 'new').
		self should: [(class >> #firstname) hasCoveringTestMethods].]
	ensure: [
		class rename: oldName.
		CSCoverageTracingWrapper unregisterClass: CSExamplePerson]! !

!CSTddAutoRunTests methodsFor: 'test method events' stamp: 'test 9/21/2009 22:40'!
testRepro
	| selector source aSuite runner |
	CSExamplePerson methodsDo: [ :method |
		method 
			resetCoveringTestMethods;
			resetFixedTestMethods ].
	
	selector := #firstname.
	source := CSExamplePerson sourceCodeAt: selector.
	
	CSCoverageTracingWrapper registerClass: CSExamplePerson.
	
	[
		aSuite := TestSuite new.
		aSuite addTest: (CSExampleTest selector: #testFirstnameAccessors).
		runner := CSTestRunner new.
		runner runSuite: aSuite.
		self should: [ runner result passed size = 1 ]]
	ensure: [
		CSCoverageTracingWrapper unregisterClass: CSExamplePerson.
		].! !

CSAutoTddTestBase subclass: #CSTestRunnerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Tests'!

!CSTestRunnerTest methodsFor: 'as yet unclassified' stamp: 'bs 10/7/2009 09:17'!
testResetReporter
	|aSuite|
	aSuite := TestSuite new.
	aSuite addTest: (CSExampleTest selector: #testFirstnameAccessors).
	
	testRunner runSuite: aSuite.
	testRunner resetReporter.
	self assert: [testRunner reporter isNil].! !

!CSTestRunnerTest methodsFor: 'as yet unclassified' stamp: 'bs 10/7/2009 08:25'!
testRunAndDebugSuite
	|aSuite|
	aSuite := TestSuite new.
	aSuite addTest: (CSExampleTest selector: #testFirstnameAccessors).
	
	testRunner 
		runSuite: aSuite;
		reset;
		debugSuite: aSuite.! !

CSTestBase subclass: #CSBasicTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Tests'!

!CSBasicTests methodsFor: 'as yet unclassified' stamp: 'bs 10/28/2009 08:01'!
testConcreteClassCoverage
	| aTestRunner aSuite method wrapper |
	method := (CSExamplePerson >> #firstname) unwrappedMethod.
	method resetAllCoverageData.
	self deny: [method hasCoveringTestMethods].
	
	wrapper := CSCoverageTracingWrapper on: #firstname inClass: CSExamplePerson.
	wrapper install.
	
	aTestRunner := CSTestRunner new.
	aSuite := CSExampleTest suite.
	aTestRunner runSuite: (CSExampleTest suite).
	
	self assert: [method hasCoveringTestMethods].
	self deny: [ (method coveringTestMethodsWhenReceiverWasOfKind: CSExamplePerson) size = 0 ].
	wrapper uninstall.
	
	self deny: [(CSExamplePerson >> #firstname) isMwMethodWrapper]! !

!CSBasicTests methodsFor: 'as yet unclassified' stamp: 'bs 9/23/2009 21:47'!
testCoverageApi
	| testMethod method |
	method := (CSExamplePerson >> #firstname) clientMethod.
	testMethod := (CSExampleTest >> #testFirstnameAccessors) clientMethod.
	method resetAllCoverageData.
	testMethod resetAllCoverageData.
	testMethod called: method inDepth: 1 receiver: nil.
	self should: [method hasCoveringTestMethods].
	self should: [method coveringTestMethods size = 1].
	self should: [method fixedTestMethods size = 0].
	self should: [method coveringAndNotFixedTestMethods size = 1].
	self should: [testMethod coveredMethods includes: method].
	self should: [testMethod coveredMethodsStatistics isEmpty not].
	method resetAllCoverageData.
	testMethod resetAllCoverageData.! !

!CSBasicTests methodsFor: 'as yet unclassified' stamp: 'bs 10/8/2009 15:50'!
testRetrievingTestsForMethod
	| aSuite aTestRunner |
	aTestRunner := CSTestRunner new.
	self undoInTearDownDo: [
		self traceClass: CSExamplePerson].
	aSuite := CSExampleTest suite.
	aTestRunner runSuite: aSuite. 
	self assert: ((CSExamplePerson>>#firstname:) coveringTestMethods includes: CSExampleTest >> #testFirstnameAccessors).! !

!CSBasicTests methodsFor: 'as yet unclassified' stamp: 'test 9/21/2009 08:45'!
testRetrievingTestsForQuickReturnMethod
	| aTestRunner aSuite |
	aTestRunner := CSTestRunner new.
	self undoInTearDownDo: [
		self traceClass: CSExamplePerson].
	aSuite := CSExampleTest suite.
	aTestRunner runSuite: aSuite.
	self assert: ((CSExamplePerson>>#firstname) coveringTestMethods includes: CSExampleTest >> #testFirstnameAccessors).! !

!CSBasicTests methodsFor: 'as yet unclassified' stamp: 'bs 10/6/2009 14:31'!
testStartStopSystemEventHandling
	| handlesSystemEvents | 
	handlesSystemEvents := CSCoverageTracingWrapper handlesSystemEvents.
	handlesSystemEvents
		ifTrue: [
			CSCoverageTracingWrapper stopHandlingSystemEvents.
			self assert: [CSCoverageTracingWrapper handlesSystemEvents not].
			CSCoverageTracingWrapper startHandlingSystemEvents ]
		ifFalse: [
			CSCoverageTracingWrapper startHandlingSystemEvents.
			self assert: [CSCoverageTracingWrapper handlesSystemEvents].
			CSCoverageTracingWrapper stopHandlingSystemEvents ]! !

!CSTestBase methodsFor: 'as yet unclassified' stamp: 'test 9/18/2009 17:17'!
createdClasses
	^ createdClasses ifNil: [createdClasses := OrderedCollection new]! !

!CSTestBase methodsFor: 'as yet unclassified' stamp: 'test 9/21/2009 08:40'!
installMethod: source inClass: aClass
	|selector|
	selector := aClass compile: source.
	self undoInTearDown ifTrue: [
		self installedMethods add: {aClass. selector}].
	^ selector! !

!CSTestBase methodsFor: 'as yet unclassified' stamp: 'bs 9/17/2009 20:56'!
installedMethods
	^ installedMethods ifNil: [installedMethods := OrderedCollection new]! !

!CSTestBase methodsFor: 'as yet unclassified' stamp: 'test 9/21/2009 08:43'!
registerClass: aClass
	CSCoverageTracingWrapper registerClass: aClass.
	self undoInTearDown ifTrue: [
		self registeredClasses add: aClass].
	.! !

!CSTestBase methodsFor: 'as yet unclassified' stamp: 'bs 10/6/2009 11:02'!
registerPackage: aPackageInfo
	CSCoverageTracingWrapper registerPackage: aPackageInfo.
	self undoInTearDown ifTrue: [
		self registeredPackages add: aPackageInfo].! !

!CSTestBase methodsFor: 'as yet unclassified' stamp: 'test 9/17/2009 21:51'!
registeredClasses
	^ registeredClasses ifNil: [registeredClasses := OrderedCollection new]! !

!CSTestBase methodsFor: 'as yet unclassified' stamp: 'bs 10/6/2009 11:02'!
registeredPackages
	^ registeredPackages ifNil: [registeredPackages := OrderedCollection new]! !

!CSTestBase methodsFor: 'as yet unclassified' stamp: 'test 9/17/2009 21:58'!
reinstallRemovedMethods
	|aClass selector sourceCode |
	self removedMethods do: [ :classSelectorSourceCodeTuple | 
		aClass := classSelectorSourceCodeTuple first.
		selector := classSelectorSourceCodeTuple second.
		sourceCode := classSelectorSourceCodeTuple third.
		(aClass includesSelector: selector)
			ifFalse: [ aClass compile: sourceCode ] ]! !

!CSTestBase methodsFor: 'as yet unclassified' stamp: 'bs 10/6/2009 11:11'!
removeCreatedClasses
	self createdClasses copy do: [ :aClass | 
		aClass removeFromSystem.
		(Smalltalk classNamed: aClass name) 
			ifNotNil: [aClass removeFromSystem].
		self createdClasses remove: aClass. ]! !

!CSTestBase methodsFor: 'as yet unclassified' stamp: 'bs 9/17/2009 20:59'!
removeInstalledMethods
	| aClass selector |
	self installedMethods do: [:classSelectorTuple |
		aClass := classSelectorTuple first.
		selector := classSelectorTuple second.
		(aClass includesSelector: selector) 
			ifTrue: [ aClass removeSelector: selector ] ]! !

!CSTestBase methodsFor: 'as yet unclassified' stamp: 'test 9/21/2009 08:48'!
removeMethod: aCompiledMethod inClass: aClass
	|selector sourceCode|
	selector := aCompiledMethod selector.
	sourceCode := aClass sourceCodeAt: selector.
	self removedMethods add: {aClass. selector. sourceCode}.
	aClass removeSelector: selector. ! !

!CSTestBase methodsFor: 'as yet unclassified' stamp: 'bs 9/17/2009 20:28'!
removedMethods
	^ removedMethods ifNil: [removedMethods := OrderedCollection new]! !

!CSTestBase methodsFor: 'as yet unclassified' stamp: 'bs 10/6/2009 11:42'!
reregisterPackages
	self unregisteredPackages copy do: [:aPackageInfo |
		CSCoverageTracingWrapper registerPackage: aPackageInfo.
		self unregisteredPackages remove: aPackageInfo ].! !

!CSTestBase methodsFor: 'as yet unclassified' stamp: 'bs 9/11/2009 21:26'!
setUp
	super setUp.
	tddAutoRunTestRunner := CSTestRunner 
		allSubInstances select: [:runner | runner isInTddAutoRunMode].
	tddAutoRunTestRunner do: [:runner | runner tddAutoRunStop].! !

!CSTestBase methodsFor: 'as yet unclassified' stamp: 'bs 10/6/2009 11:21'!
tearDown
	self
		unregisterClasses;
		unregisterPackages;
		reregisterPackages;
		removeCreatedClasses;
		reinstallRemovedMethods;
		removeInstalledMethods.
	tddAutoRunTestRunner do: [:runner | runner tddAutoRunStart].
	super tearDown.! !

!CSTestBase methodsFor: 'as yet unclassified' stamp: 'test 9/21/2009 08:47'!
traceClass: aClass
	(CSCoverageTracingWrapper registeredClasses includes: aClass)
		ifFalse: [ self registerClass: aClass ]! !

!CSTestBase methodsFor: 'as yet unclassified' stamp: 'bs 10/6/2009 11:01'!
tracePackage: aPackageInfo
	(CSCoverageTracingWrapper registeredPackages includes: aPackageInfo)
		ifFalse: [ self registerPackage: aPackageInfo ]! !

!CSTestBase methodsFor: 'accessing' stamp: 'test 9/21/2009 08:37'!
undoInTearDown
	^ undoInTearDown ifNil: [undoInTearDown := false]! !

!CSTestBase methodsFor: 'accessing' stamp: 'test 9/21/2009 08:36'!
undoInTearDown: anObject
	undoInTearDown := anObject! !

!CSTestBase methodsFor: 'as yet unclassified' stamp: 'test 9/21/2009 08:37'!
undoInTearDownDo: aBlock
	self undoInTearDown: true.
	aBlock value.
	self undoInTearDown: false.! !

!CSTestBase methodsFor: 'as yet unclassified' stamp: 'bs 9/17/2009 20:47'!
unregisterClasses
	self registeredClasses do: [:aClass |
		CSCoverageTracingWrapper unregisterClass: aClass ].! !

!CSTestBase methodsFor: 'as yet unclassified' stamp: 'bs 10/6/2009 11:13'!
unregisterPackages
	self registeredPackages do: [:aPackageInfo |
		CSCoverageTracingWrapper unregisterPackage: aPackageInfo ].! !

!CSTestBase methodsFor: 'as yet unclassified' stamp: 'bs 10/6/2009 11:20'!
unregisteredPackages
	^ unregisteredPackages ifNil: [unregisteredPackages := OrderedCollection new]! !

CSTestBase subclass: #CSTracingWrapperTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Tests'!

!CSTracingWrapperTest methodsFor: 'as yet unclassified' stamp: 'bs 9/23/2009 16:00'!
codeSightPackage
	
	^ PackageInfo named: 'CodeSight'.! !

!CSTracingWrapperTest methodsFor: 'as yet unclassified' stamp: 'bs 10/6/2009 11:06'!
createWrappingTestClass
	| aClass |
	aClass := Object subclass: #CSFooBarWrapping
					instanceVariableNames: ''
					classVariableNames: ''
					poolDictionaries: ''
					category: 'CodeSight-Tests'.
	self undoInTearDown ifTrue: [
		self createdClasses add: aClass].
	^ aClass! !

!CSTracingWrapperTest methodsFor: 'registration' stamp: 'bs 10/6/2009 10:56'!
testCompiledMethodAccess

	CSExamplePerson methodsDo: [:method | 
		method 
			resetCoveringTestMethods;
			resetFixedTestMethods ].
			
	self undoInTearDownDo: [
		self traceClass: CSExamplePerson ].
	
	self should: [(CSExamplePerson >> #firstname) isMwMethodWrapper].
	self shouldnt: [(CSExamplePerson >> #firstname) hasCoveringTestMethods] raise: Error.! !

!CSTracingWrapperTest methodsFor: 'registration' stamp: 'bs 10/6/2009 11:08'!
testDynamicRegistrationAndWrappingOfClassesAndMethods
	|aClass aClassName selector|
	
	selector := #firstname.
	self undoInTearDownDo: [
		self tracePackage: self codeSightPackage.
		aClass := self createWrappingTestClass ].
	
	aClassName := aClass name.
	self should: [CSCoverageTracingWrapper registeredClasses includes: aClass].
	aClass compile: (CSExamplePerson sourceCodeAt: selector).
	self should: [(aClass >> selector) isMwMethodWrapper]. 
	self should: [(CSCoverageTracingWrapper registeredMethodsAt: aClass) includes: selector].
	aClass removeSelector: selector.
	self shouldnt: [(CSCoverageTracingWrapper registeredMethodsAt: aClass) includes: selector].
	aClass compile: (CSExamplePerson sourceCodeAt: selector).
	aClass removeFromSystem. 
	self shouldnt: [CSCoverageTracingWrapper registeredClasses includes: aClass].
	self shouldnt: [(CSCoverageTracingWrapper registeredMethodsAt: aClass) includes: selector]! !

!CSTracingWrapperTest methodsFor: 'registration' stamp: 'bs 10/6/2009 11:16'!
testReregistrationAfterClassModification
	"note, classes have idendity. modification does only change the same object.
	 registration is handled with classes' identity"
	|instVarName nRegisteredMethods|
	instVarName := 'foobar'. 
	self undoInTearDownDo: [
		self traceClass: CSExamplePerson ].
	
	[	nRegisteredMethods := CSCoverageTracingWrapper registeredMethods size.
		CSExamplePerson addInstVarName: instVarName.
		self should: [(CSExamplePerson >> #firstname) isKindOf: CompiledMethod].
		self should: [nRegisteredMethods == CSCoverageTracingWrapper registeredMethods size]]
	ensure: [
		(CSExamplePerson instVarNames includes: instVarName)
				ifTrue: [CSExamplePerson removeInstVarName: instVarName] ]! !

!CSTracingWrapperTest methodsFor: 'registration' stamp: 'bs 10/6/2009 11:17'!
testRewrapAfterChangeOfWrappedMethod
 
	self undoInTearDownDo: [
		self traceClass: CSExamplePerson ].
	
	CSExamplePerson compile: (CSExamplePerson sourceCodeAt: #firstname).
	self should: [(CSExamplePerson >> #firstname) isMwMethodWrapper].! !

!CSTracingWrapperTest methodsFor: 'registration' stamp: 'bs 10/28/2009 08:09'!
testUninstall
	|wasRegistered|
	wasRegistered := CSCoverageTracingWrapper isRegisteredMethod: #firstname inClass: CSExamplePerson.
	wasRegistered ifTrue: [CSCoverageTracingWrapper unregisterMethod: #firstname inClass: CSExamplePerson ].
	
	CSCoverageTracingWrapper registerMethod: #firstname inClass: CSExamplePerson.
	CSCoverageTracingWrapper unregisterMethod: #firstname inClass: CSExamplePerson.
	
	self deny: [(CSExamplePerson >> #firstname) isMwMethodWrapper].
	
	wasRegistered ifTrue: [CSCoverageTracingWrapper registerMethod: #firstname inClass: CSExamplePerson ].! !

!CSTracingWrapperTest methodsFor: 'registration' stamp: 'bs 10/6/2009 21:20'!
testUnregisterAllAndReset
	| packages classes methods |
	packages := CSCoverageTracingWrapper registeredPackages copy.
	classes := CSCoverageTracingWrapper registeredClasses copy.
	methods := CSCoverageTracingWrapper registeredMethods copy.
	
	CSCoverageTracingWrapper registerClass: CSExamplePerson.
	CSCoverageTracingWrapper unregisterAllAndReset.
	self assert: [CSCoverageTracingWrapper registeredPackages size = 0].
	self assert: [CSCoverageTracingWrapper registeredClasses size = 0].
	self assert: [CSCoverageTracingWrapper registeredMethods keys size = 0].
	self assert: [(CSExamplePerson >> #firstname) isMwMethodWrapper not].
	
	packages do: [:ea | CSCoverageTracingWrapper registerPackage: ea].
	classes do: [:ea | CSCoverageTracingWrapper registerClass: ea].
	methods keysAndValuesDo: [ :aClass :selectors | 
		selectors do: [:s | CSCoverageTracingWrapper registerMethod: s inClass: aClass] ].! !

!CSTracingWrapperTest methodsFor: 'registration' stamp: 'bs 10/6/2009 11:53'!
testUnregisterPackage
	| aPackage |
	aPackage := self codeSightPackage.
	(CSCoverageTracingWrapper registeredPackages includes: aPackage)
		ifTrue: [self unregisteredPackages add: aPackage]
		ifFalse: [self registeredPackages add: aPackage].
	
	
	CSCoverageTracingWrapper registerPackage: aPackage.
	self should: [(CSExamplePerson >> #firstname) isMwMethodWrapper].
	CSCoverageTracingWrapper unregisterPackage: aPackage.
	self shouldnt: [(CSExamplePerson >> #firstname) isMwMethodWrapper].
	! !

!CSTracingWrapperTest methodsFor: 'registration' stamp: 'bs 10/6/2009 15:37'!
testWrapperInstallation
	| aPackage |
	aPackage := self codeSightPackage.
	(CSCoverageTracingWrapper registeredPackages includes: aPackage)
		ifTrue: [self unregisteredPackages add: aPackage]
		ifFalse: [self registeredPackages add: aPackage].
	
	CSCoverageTracingWrapper registerPackage: aPackage.
	self should: [(CSExamplePerson >> #firstname) isMwMethodWrapper].
	self shouldnt: [(CSExampleTest >> #testFirstnameAccessors) isMwMethodWrapper].
	
	CSCoverageTracingWrapper unregisterPackage: aPackage.
	self shouldnt: [(CSExamplePerson >> #firstname) isMwMethodWrapper].
	
	CSCoverageTracingWrapper registerPackage: aPackage.
	CSCoverageTracingWrapper registerPackage: aPackage.
	CSCoverageTracingWrapper unregisterPackage: aPackage.
	self shouldnt: [(CSExamplePerson >> #firstname) isMwMethodWrapper].! !

!Symbol methodsFor: '*CodeSight' stamp: 'bs 9/10/2009 08:54'!
isTestSelector
	^ (self last ~= $:) and: ['test*' match: self]! !

TestRunner subclass: #CSTestRunner
	instanceVariableNames: 'traceAspect classesToBeTraced isInTddAutoRunMode testCasesToRun runsTestsInBackground doForEachCoveredMethod methodsCoveredBeforeRun'
	classVariableNames: 'WaitingTestRunners CurrentAutoTestRunner RunInBackgroundMonitor'
	poolDictionaries: ''
	category: 'CodeSight-TestTracer'!

CSTestRunner class
	instanceVariableNames: 'classesToBeTraced'!

CSTestRunner class
	instanceVariableNames: 'classesToBeTraced'!

!CSTestRunner class methodsFor: 'accessing' stamp: 'rkrk 9/22/2009 05:35'!
currentAutoTestRunner

	^ CurrentAutoTestRunner ifNil: [
		self new
			tddAutoRunStart;
			yourself].! !

!CSTestRunner class methodsFor: 'as yet unclassified' stamp: 'bs 4/16/2009 15:28'!
initialize
	"CSTestRunner initialize"
	self registerInWorldMenu; registerInToolsFlap.! !

!CSTestRunner class methodsFor: 'synchronizing' stamp: 'bs 9/15/2009 15:52'!
measureExecutionTimesForPackagesWith: aString
	"CSTestRunner measureExecutionTimes"
	|packages classes testCase time testClasses testCaseTimes result coveredMethods coveringTestMethods coveredMethodsTestTimeDeltas classTestTime aTestRunner aSuite |
	packages := PackageOrganizer default packages select: [:p | p packageName startsWith: aString].
	packages do: [:p | CSCoverageTracingWrapper registerPackage: p].
	classes := (packages gather: [:p | p classes]) asSet.

	aTestRunner := CSTestRunner new.
	testCase := nil.
	time := nil.

	testClasses := classes select: [:class | class inheritsFrom: TestCase].
	testCaseTimes := Dictionary new.
	testClasses do: [:testClass | 
		testClass selectors select: [:s | s isTestSelector] thenDo: [:s | 
			aSuite := TestSuite new.
			aSuite addTest: (testClass selector: s).
			time := [aTestRunner runSuite: aSuite] timeToRun.
			testCaseTimes at: (testClass >> s) put: time]].

	result := Dictionary new.	
	coveredMethods := nil.
	coveredMethodsTestTimeDeltas := nil.
	classes select: [:c | c methodDict values contains: [:m | m hasCoveringTestMethods]]
	 		  thenDo: [:aClass |
		coveredMethods := aClass methodDict values select: [:m | m hasCoveringTestMethods ].
		coveringTestMethods := (coveredMethods gather: [:m | m coveringTestMethods]) asSet.
		classTestTime := (coveringTestMethods collect: [:m | testCaseTimes at: m ifAbsent: [0]]) sum.
		
		coveredMethodsTestTimeDeltas := classTestTime - (coveredMethods collect: [:cm | 
			(cm coveringTestMethods collect: [:tm | testCaseTimes at: tm ifAbsent: [0]]) sum]).
		
		coveredMethodsTestTimeDeltas ifNotEmpty: [
			result at: aClass put: {coveredMethods size. coveredMethodsTestTimeDeltas max. coveredMethodsTestTimeDeltas average}]].
	
	packages do: [:p | CSCoverageTracingWrapper unregisterPackage: p].
	^ result
! !

!CSTestRunner class methodsFor: 'as yet unclassified' stamp: 'bs 4/22/2009 15:14'!
registerInToolsFlap
	self environment at: #Flaps ifPresent: [ :class |
		class
			registerQuad: #( CSTestRunner build 'CodeSight Test Runner' 'A production scale test-runner for XP Forums.' ) forFlapNamed: 'Tools';
			replaceToolsFlap ].! !

!CSTestRunner class methodsFor: 'as yet unclassified' stamp: 'mab 4/2/2009 20:33'!
registerInWorldMenu
	self environment at: #TheWorldMenu ifPresent: [ :class |
		class registerOpenCommand: (Array 
			with: 'CodeSight Test Runner' 
			with: (Array
				with: self
				with: #open)) ].! !

!CSTestRunner class methodsFor: 'synchronizing' stamp: 'test 9/17/2009 23:32'!
resetSourceCodeAccessMonitor
	^ RunInBackgroundMonitor := nil! !

!CSTestRunner class methodsFor: 'synchronizing' stamp: 'bs 10/28/2009 09:48'!
resetWaitingAndCurrentTestRunners
	"self resetWaitingAndCurrentTestRunners"
	self waitingTestRunners: nil.
	CurrentAutoTestRunner := nil.! !

!CSTestRunner class methodsFor: 'synchronizing' stamp: 'bs 9/14/2009 10:50'!
sourceCodeAccessMonitor
	^ RunInBackgroundMonitor ifNil: [ RunInBackgroundMonitor := Monitor new ]! !

!CSTestRunner class methodsFor: 'synchronizing' stamp: 'bs 9/13/2009 14:53'!
tddAutoRunStartFor: aCSTestRunner
	CurrentAutoTestRunner
		ifNotNil: [
			CurrentAutoTestRunner disableTddAutoRunMode.
			self waitingTestRunners add: CurrentAutoTestRunner].
		
	CurrentAutoTestRunner := aCSTestRunner enableTddAutoRunMode.! !

!CSTestRunner class methodsFor: 'synchronizing' stamp: 'bs 9/13/2009 14:55'!
tddAutoRunStopFor: aCSTestRunner
	aCSTestRunner disableTddAutoRunMode.
	(CurrentAutoTestRunner == aCSTestRunner)
		ifTrue: [
			CurrentAutoTestRunner := nil.
			self waitingTestRunners ifNotEmpty: [
				CurrentAutoTestRunner := self waitingTestRunners removeLast.
				CurrentAutoTestRunner enableTddAutoRunMode].
			]
		ifFalse: [
			self waitingTestRunners remove: aCSTestRunner ifAbsent: []].! !

!CSTestRunner class methodsFor: 'synchronizing' stamp: 'bs 10/28/2009 09:48'!
waitingTestRunners
	^ WaitingTestRunners ifNil: [WaitingTestRunners := OrderedCollection new.]! !

!CSTestRunner class methodsFor: 'synchronizing' stamp: 'bs 9/23/2009 17:32'!
waitingTestRunners: anObject
	^ WaitingTestRunners := anObject! !

!CSTestRunner methodsFor: 'running' stamp: 'bs 10/7/2009 09:22'!
basicSetUpSuite: aTestSuite 
	| testMethod |
	super basicSetUpSuite: aTestSuite.
	
	aTestSuite tests do: [ :aTestCase | 
		testMethod := aTestCase class >> aTestCase selector.
		self methodsCoveredBeforeRun at: testMethod put: testMethod coveredMethods.
		testMethod resetCoveredMethodsStatistics ].

	CSCoverageTracingWrapper activateTracing.! !

!CSTestRunner methodsFor: 'running' stamp: 'bs 10/7/2009 09:36'!
basicTearDownSuite: aTestSuite
	CSCoverageTracingWrapper deactivateTracing.
	
	self methodsCoveredBeforeRun keysAndValuesDo: [:testMethod :coveredMethods |
		coveredMethods do: [:coveredMethod |
			coveredMethod removeFixedTestMethodIfNotCoveringAnymore: testMethod ]]. 
	
	self resetMethodsCoveredBeforeRun.
	super basicTearDownSuite: aTestSuite.
	! !

!CSTestRunner methodsFor: 'building' stamp: 'bs 9/15/2009 12:02'!
buildControlPanelWith: aBuilder
	^ aBuilder pluggablePanelSpec new
		layout: #vertical;
		children: {
			self buildButtonsWith: aBuilder.
			self buildTddControlButtonsWith: aBuilder
			};
		yourself.! !

!CSTestRunner methodsFor: 'building' stamp: 'bs 9/15/2009 12:18'!
buildTddControlButtonsWith: aBuilder
	^ aBuilder pluggablePanelSpec new
		model: self;
		layout: #horizontal;
		children: (self tddFlags collect: [ :each |
			aBuilder pluggableActionButtonSpec new
				model: self; 
				label: each first;
				action: each second;
				yourself ]);
		yourself.! !

!CSTestRunner methodsFor: 'building' stamp: 'bs 9/15/2009 11:47'!
buildWith: aBuilder
	| window |
	window := aBuilder pluggableWindowSpec new
		model: self; label: self label; extent: self extent;
		children: (OrderedCollection new 
			add: ((self buildSuitesWith: aBuilder)
				frame: (0.00 @ 0.00 corner: 0.25 @ 0.20 );
				yourself);
			add: ((self buildCategoriesWith: aBuilder)
				frame: (0.00 @ 0.20 corner: 0.25 @ 0.84 );
				yourself);				
			add: ((self buildClassesWith: aBuilder)
				frame: (0.25 @ 0.00 corner: 0.50 @ 0.84 );
				yourself);
			add: ((self buildStatusWith: aBuilder)
				frame: (0.50 @ 0.00 corner: 1.00 @ 0.08);
				yourself);
			add: ((self buildFailureListWith: aBuilder)
				frame: (0.50 @ 0.08 corner: 1.00 @ 0.50);
				yourself);
			add: ((self buildErrorListWith: aBuilder)
				frame: (0.50 @ 0.50 corner: 1.00 @ 0.84);
				yourself);
			add: ((self buildControlPanelWith: aBuilder)
				frame: (0.00 @ 0.84 corner: 1.00 @ 1.00);
				yourself);
			yourself);
		closeAction: #close;
		yourself.
	^ aBuilder build: window.! !

!CSTestRunner methodsFor: 'event handling' stamp: 'bs 9/11/2009 18:04'!
classAdded: anAddedEvent
	! !

!CSTestRunner methodsFor: 'event handling' stamp: 'test 9/21/2009 20:40'!
classModified: aModifiedEvent
	| modifiedClass collectingSelector |
	modifiedClass := aModifiedEvent oldItem.
	collectingSelector := (modifiedClass inheritsFrom: TestCase) 
		ifTrue: [#collectTestCasesOfTestClass: ]
		ifFalse: [#collectTestCasesCoveringClass:].
	
	modifiedClass withAllSubclassesDo: [:subclass | 
		self testCasesToRun addAll: 
			(self perform: collectingSelector with: subclass)].
			
	self runOpenTestCasesInSuite.! !

!CSTestRunner methodsFor: 'event handling' stamp: 'test 9/21/2009 22:55'!
classRemoved: aRemovedEvent
	| aClass |
	aClass := aRemovedEvent item. 
	self handleRemovedMethods: (aClass methodDict values) inClass: aClass.
	self runOpenTestCasesInSuite.! !

!CSTestRunner methodsFor: 'building' stamp: 'rkrk 9/22/2009 05:39'!
close

	self
		disableRunningTestsInBackground;
		tddAutoRunStop;
		changed: #runnerClosed.! !

!CSTestRunner methodsFor: 'event handling' stamp: 'bs 9/11/2009 11:18'!
collectTestCasesCoveringClass: aClass 
	^ (aClass methodDict values gather: [ :method | self collectTestCasesCoveringMethod: method ]) asSet! !

!CSTestRunner methodsFor: 'event handling' stamp: 'test 9/20/2009 14:25'!
collectTestCasesCoveringMethod: aMethod 
	^ aMethod coveringTestMethods collect: [ :aTestMethod | aTestMethod newTestCase ]! !

!CSTestRunner methodsFor: 'event handling' stamp: 'bs 9/15/2009 08:58'!
collectTestCasesOfTestClass: aTestClass 
	^ aTestClass selectors 
			select: [ :aSelector | aSelector isTestSelector ]
			thenCollect: [ :aSelector | aTestClass selector: aSelector ].! !

!CSTestRunner methodsFor: 'running' stamp: 'bs 4/30/2009 12:09'!
debugSuite: aTestSuite
	self basicRunSuite: aTestSuite do: [ :each | self debugTest: each ].! !

!CSTestRunner methodsFor: 'running' stamp: 'bs 10/6/2009 21:14'!
debugTest: aTestCase
	| outerTest | 
	outerTest := CSCoverageTracingWrapper runningTestMethod.
	CSCoverageTracingWrapper testMethodGoingToRun: (aTestCase class >> aTestCase selector) unwrappedMethod.
	aTestCase debug.
	CSCoverageTracingWrapper testMethodGoingToRun: outerTest.! !

!CSTestRunner methodsFor: 'background processing' stamp: 'bs 9/14/2009 16:16'!
disableRunningTestsInBackground
	^ runsTestsInBackground := false! !

!CSTestRunner methodsFor: 'auto run mode' stamp: 'bs 9/13/2009 14:46'!
disableTddAutoRunMode
	self isInTddAutoRunMode: false.
	CSCoverageTracingWrapper systemEventPostProcessingHandlers remove: self ifAbsent: [].! !

!CSTestRunner methodsFor: 'running' stamp: 'test 9/18/2009 21:01'!
doForEachCoveredMethod
	^ doForEachCoveredMethod ifNil: [ doForEachCoveredMethod := [ :aTestMethod :anAppMethod | ] ]! !

!CSTestRunner methodsFor: 'running' stamp: 'bs 10/7/2009 09:38'!
doForEachCoveredMethod: aBlock
	^ doForEachCoveredMethod := aBlock.! !

!CSTestRunner methodsFor: 'background processing' stamp: 'bs 9/14/2009 16:16'!
enableRunningTestsInBackground
	^ runsTestsInBackground := true! !

!CSTestRunner methodsFor: 'auto run mode' stamp: 'bs 9/13/2009 14:46'!
enableTddAutoRunMode
	self isInTddAutoRunMode: true.
	CSCoverageTracingWrapper systemEventPostProcessingHandlers add: self! !

!CSTestRunner methodsFor: 'running' stamp: 'bs 10/6/2009 15:39'!
failedTestCases
	^ self result failures copy addAll: self result errors! !

!CSTestRunner methodsFor: 'event handling' stamp: 'bs 9/23/2009 20:09'!
handleRemovedMethods: methods inClass: aClass
	| selector subOrSupMethods fixedTestMethods removedMethod |

	subOrSupMethods := IdentityDictionary new.
	fixedTestMethods := IdentityDictionary new.

	methods collect: [:m | m clientMethod] thenDo: [ :method | 
		selector := method selector.
		(method overriddenAndOverridingMethodsIn: aClass) do: [:subOrSupMethod | 
			subOrSupMethods at: subOrSupMethod put: method].
		fixedTestMethods at: method put: method fixedTestMethods.
		
		self testCasesToRun addAll: (self collectTestCasesCoveringMethod: method).
		((aClass inheritsFrom: TestCase) and: [selector isTestSelector])
			ifTrue: [
				method resetCoveredMethodsStatistics.
				self removeFromFailedTestsIfPresent: selector inClass: aClass]
			ifFalse: [
				method 
					resetCoveringTestMethods;
					resetFixedTestMethods ] ].
			
	self doForEachCoveredMethod: [:aTestMethod :anAppMethod |
		(subOrSupMethods includesKey: anAppMethod) 
			ifTrue: [
				removedMethod := subOrSupMethods at: anAppMethod.
				anAppMethod fixesAll: (fixedTestMethods at: removedMethod)]].! !

!CSTestRunner methodsFor: 'auto run mode' stamp: 'bs 9/11/2009 14:52'!
isInTddAutoRunMode
	^ isInTddAutoRunMode ifNil: [isInTddAutoRunMode := false].! !

!CSTestRunner methodsFor: 'auto run mode' stamp: 'bs 9/11/2009 14:51'!
isInTddAutoRunMode: aBoolean
	^ isInTddAutoRunMode := aBoolean.! !

!CSTestRunner methodsFor: 'building' stamp: 'mab 4/2/2009 20:33'!
label
	^ 'CodeSight Test Runner'! !

!CSTestRunner methodsFor: 'event handling' stamp: 'bs 10/6/2009 18:43'!
methodAdded: anAddedEvent 
	| selector class method |
	selector := anAddedEvent itemSelector.
	class := anAddedEvent itemClass.
	method := anAddedEvent item.
	((class inheritsFrom: TestCase) and: [selector isTestSelector])
		ifTrue: [ 
			self testCasesToRun add: (class selector: selector) ]
		ifFalse: [ 
			self testCasesToRun addAll:
				(((method overriddenAndOverridingMethodsIn: class) 
					gather: [ :supOrSubMethod | supOrSubMethod coveringTestMethods ]) 
						asSet collect: [:aTestMethod | aTestMethod newTestCase]).
			
			self doForEachCoveredMethod: [:aTestMethod :anAppMethod |
				(anAppMethod = method) ifTrue: [
					anAppMethod fixesAll: 
						((anAppMethod overriddenAndOverridingMethodsIn: class) 
							gather: [:supOrSubMethod | supOrSubMethod fixedTestMethods])]]].
		
	self runOpenTestCasesInSuite! !

!CSTestRunner methodsFor: 'event handling' stamp: 'bs 10/6/2009 12:05'!
methodModified: aModifiedEvent 
	| selector class method coveredMethods |
	selector := aModifiedEvent itemSelector.
	class := aModifiedEvent itemClass.
	method := aModifiedEvent item.
	method fixesAll: (aModifiedEvent oldItem fixedTestMethods).
	
	((class inheritsFrom: TestCase) and: [selector isTestSelector])
		ifTrue: 
			[ self testCasesToRun add: (class selector: selector) ]
		ifFalse: [
			self testCasesToRun addAll: 
				((aModifiedEvent oldItem) coveringTestMethods 
					collect: [:testMethod | testMethod newTestCase]).
			
			coveredMethods := IdentityDictionary new.
			((aModifiedEvent oldItem) coveringTestMethods) do: [:testMethod |
				coveredMethods at: testMethod put: testMethod coveredMethods ].
			
			self doForEachCoveredMethod: [:aTestMethod :anAppMethod |
				((coveredMethods at: aTestMethod) includes: anAppMethod) ifFalse: [
					anAppMethod fixesAll: method fixedTestMethods ] ] ].
			
	self runOpenTestCasesInSuite.! !

!CSTestRunner methodsFor: 'event handling' stamp: 'test 9/21/2009 23:20'!
methodRemoved: aRemovedEvent
	| class method |
	class := aRemovedEvent itemClass.
	method := aRemovedEvent item.
	self handleRemovedMethods: {method} inClass: class.
	self runOpenTestCasesInSuite.! !

!CSTestRunner methodsFor: 'running' stamp: 'test 9/21/2009 10:45'!
methodsCoveredBeforeRun
	^ methodsCoveredBeforeRun ifNil: [methodsCoveredBeforeRun := IdentityDictionary new]! !

!CSTestRunner methodsFor: 'event handling' stamp: 'bs 9/10/2009 22:21'!
removeFromFailedTestsIfPresent: selector inClass: class
	(Array with: self result failures with: self result errors) do: [:failedTests | 
		failedTests removeAll: (failedTests select: [:testCase | 
			(testCase selector = selector) and: [testCase class == class]])]! !

!CSTestRunner methodsFor: 'running' stamp: 'test 9/21/2009 10:43'!
resetMethodsCoveredBeforeRun
	methodsCoveredBeforeRun := nil.! !

!CSTestRunner methodsFor: 'accessing' stamp: 'bs 10/7/2009 09:18'!
resetReporter
	reporter := nil.! !

!CSTestRunner methodsFor: 'accessing' stamp: 'bs 9/10/2009 13:58'!
resetTestCasesToRun
	^ testCasesToRun := nil.! !

!CSTestRunner methodsFor: 'running' stamp: 'bs 10/7/2009 09:44'!
runOpenTestCasesInSuite
	| aSuite testMethod doForEachCoveredMethodBlock testMethodsToBeReverted |
	
	aSuite := TestSuite new.
	testMethodsToBeReverted := Set new.
	
	doForEachCoveredMethodBlock := self doForEachCoveredMethod.
	self doForEachCoveredMethod: nil.
	
	self failedTestCases do: [ :aTestCase |
		aSuite addTest: aTestCase.
		testMethod := aTestCase class >> aTestCase selector.
		testMethodsToBeReverted add: testMethod.
		testMethod doForEachCoveredMethod: [:aTestMethod :anAppMethod | 
			anAppMethod fixes: aTestMethod.
			doForEachCoveredMethodBlock valueWithArguments: {aTestMethod. anAppMethod}]].
	
	
	self testCasesToRun do: [ :aTestCase |
		aSuite addTest: aTestCase.
		testMethod := aTestCase class >> aTestCase selector.
		testMethodsToBeReverted add: testMethod.
		testMethod doForEachCoveredMethod: [:aTestMethod :anAppMethod | 
			doForEachCoveredMethodBlock valueWithArguments: {aTestMethod. anAppMethod}]].
	
	self resetTestCasesToRun.
	
	aSuite tests ifNotEmpty: [
		self reset; runSuite: aSuite].
	
	testMethodsToBeReverted do: [:method | method resetDoForEachCoveredMethod ].! !

!CSTestRunner methodsFor: 'running' stamp: 'rkrk 9/30/2009 05:05'!
runSuite: aSuite 
	| runSuiteSynchronized |
	runSuiteSynchronized := [	
		CSTestRunner sourceCodeAccessMonitor critical: [
			self changed: #startTestRun.
			super runSuite: aSuite.
			self changed: #endTestRun]].

	(self runsTestsInBackground and: [
			ProcessBrowser isUIProcess: Processor activeProcess])
		ifTrue: [ runSuiteSynchronized forkAt: Processor userBackgroundPriority ]
		ifFalse: [ runSuiteSynchronized value ]! !

!CSTestRunner methodsFor: 'running' stamp: 'bs 10/6/2009 21:14'!
runTest: aTestCase
	| outerTest | 
	outerTest := CSCoverageTracingWrapper runningTestMethod.
	CSCoverageTracingWrapper testMethodGoingToRun: (aTestCase class >> aTestCase selector) unwrappedMethod.
	super runTest: aTestCase.
	CSCoverageTracingWrapper testMethodGoingToRun: outerTest.
	
	self changed: #newTestResult with: result.! !

!CSTestRunner methodsFor: 'building' stamp: 'bs 9/15/2009 12:11'!
runningTestsInBackgroundLabel
	^ self runsTestsInBackground
		ifTrue: [ 'DisableRunningTestsInBackground' ]
		ifFalse: [ 'EnableRunningTestsInBackground' ]! !

!CSTestRunner methodsFor: 'background processing' stamp: 'bs 9/14/2009 16:17'!
runsTestsInBackground
	^ runsTestsInBackground ifNil: [runsTestsInBackground := false]! !

!CSTestRunner methodsFor: 'building' stamp: 'bs 9/15/2009 13:06'!
tddAutoRunModeLabel
	^ self isInTddAutoRunMode 
		ifTrue: [ 'Stop Tdd Auto Run Mode' ]
		ifFalse: [ 'Start Tdd Auto Run Mode' ]! !

!CSTestRunner methodsFor: 'auto run mode' stamp: 'bs 9/13/2009 14:47'!
tddAutoRunStart
	(self isInTddAutoRunMode)
		ifFalse: [
			self class tddAutoRunStartFor: self]! !

!CSTestRunner methodsFor: 'auto run mode' stamp: 'bs 9/13/2009 14:47'!
tddAutoRunStop
	self class tddAutoRunStopFor: self! !

!CSTestRunner methodsFor: 'building' stamp: 'bs 9/15/2009 12:03'!
tddFlags
	^ #(( #tddAutoRunModeLabel #toggleTddAutoRunMode )
		( #runningTestsInBackgroundLabel #toggleRunningTestsInBackground )).! !

!CSTestRunner methodsFor: 'accessing' stamp: 'bs 9/10/2009 13:56'!
testCasesToRun
	^ testCasesToRun ifNil: [testCasesToRun := OrderedCollection new].! !

!CSTestRunner methodsFor: 'building' stamp: 'bs 9/15/2009 12:21'!
toggleRunningTestsInBackground
	self runsTestsInBackground
		ifTrue: [ self disableRunningTestsInBackground. self changed: #runningTestsInBackgroundLabel. ]
		ifFalse: [ self enableRunningTestsInBackground. self changed: #runningTestsInBackgroundLabel. ]! !

!CSTestRunner methodsFor: 'building' stamp: 'bs 9/15/2009 13:07'!
toggleTddAutoRunMode
	self isInTddAutoRunMode 
		ifTrue: [ self tddAutoRunStop. self changed: #tddAutoRunModeLabel. ]
		ifFalse: [ self tddAutoRunStart. self changed: #tddAutoRunModeLabel. ]! !

!OBMorphicIcons methodsFor: '*codesight' stamp: 'mt 5/3/2009 20:44'!
csAccept

	^ MenuIcons csAcceptIcon! !

!BreakpointManager class methodsFor: '*codesight' stamp: 'bs 4/16/2009 10:27'!
compileWithSelfRemovingBreakpoint: aSymbol in: aClass 
	"Compile and return a new method containing a break statement"

	| source node method |
	source := self sourceWithSelfRemovingBreakpointFor: aSymbol in: aClass.
	node := aClass compilerClass new
		compile: source
		in: aClass 
		notifying: nil 
		ifFail: [self error: '[breakpoint] unable to install breakpoint'].
	node isNil ifTrue: [^nil].
	"dunno what the arguments mean..."
	method := node generate.
	^method! !

!BreakpointManager class methodsFor: '*codesight' stamp: 'bs 4/16/2009 10:26'!
installSelfRemovingBreakpointInClass: aClass selector: aSymbol 
	"Install a new method containing a breakpoint.
	The receiver will remember this for unstalling it later"

	| breakMethod |
	breakMethod _ self compileWithSelfRemovingBreakpoint: aSymbol in: aClass.
	breakMethod isNil
		ifTrue: [^ nil].
	self installed at: breakMethod put: aClass >> aSymbol. "old method"
	aClass basicAddSelector: aSymbol withMethod: breakMethod.! !

!BreakpointManager class methodsFor: '*codesight' stamp: 'bs 4/16/2009 10:28'!
sourceWithSelfRemovingBreakpointFor: aSymbol in: aClass 
	"Compose new source containing a break statement (currently it will be the first,
	later we want to insert it in any place)"

	| oldSource methodNode breakOnlyMethodNode sendBreakMessageNode |
	oldSource := aClass sourceCodeAt: aSymbol.
	methodNode := aClass compilerClass new
		compile: oldSource
		in: aClass 
		notifying: nil 
		ifFail: [self error: '[breakpoint] unable to install breakpoint'].
	breakOnlyMethodNode := aClass compilerClass new
		compile: 'temporaryMethodSelectorForBreakpoint
self debugAndUninstallBreakpointBefore.
^self'
		in: aClass 
		notifying: nil 
		ifFail: [self error: '[breakpoint] unable to install breakpoint'].
	sendBreakMessageNode := breakOnlyMethodNode block statements first.
	methodNode block statements addFirst: sendBreakMessageNode.
	^methodNode printString
	! !

!BreakpointManager class methodsFor: '*codesight' stamp: 'bs 4/15/2009 23:08'!
unInstallInClass: aClass selector: aSymbol
	self unInstall: (aClass compiledMethodAt: aSymbol)! !

Object subclass: #ATddBenchmarker
	instanceVariableNames: 'packages methods coveredMethods'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Analyzing'!

!ATddBenchmarker methodsFor: 'derived accessing' stamp: 'rkrk 9/21/2009 03:51'!
appMethods

	| class |
	^ self methods reject: [:ea |
		class := ea methodClass ifNil: [ea clientMethod searchForClass].
		class
			ifNil: [false]
			ifNotNil: [class inheritsFrom: TestCase]].! !

!ATddBenchmarker methodsFor: 'derived accessing' stamp: 'rkrk 9/20/2009 03:38'!
classesOfPackages

	^ (packages gather: [:p | p classes]) asSet! !

!ATddBenchmarker methodsFor: 'computing' stamp: 'rkrk 9/21/2009 04:14'!
computeTestClassesTimesPerMethodFrom: timeForEachTestClass

	| testClassesTimesPerMethod |
	testClassesTimesPerMethod := Dictionary new. "appMethod -> coveringTestClassesTime"
	(self methodsCovered: self methods) do: [:appMethod |
		testClassesTimesPerMethod
			at: appMethod
			put: (self coveringTestClassesTimeFor: appMethod from: timeForEachTestClass)].
	^ testClassesTimesPerMethod.! !

!ATddBenchmarker methodsFor: 'computing' stamp: 'rkrk 9/21/2009 04:14'!
computeTestTimesPerMethodFrom: timeForEachTest

	| testTimesPerMethod |
	testTimesPerMethod := Dictionary new. "appMethod -> coveringTestMethodsTime"
	(self methodsCovered: self methods) do: [:appMethod |
		testTimesPerMethod
			at: appMethod
			put: (self coveringTestMethodsTimeFor: appMethod from: timeForEachTest)].
	^ testTimesPerMethod.! !

!ATddBenchmarker methodsFor: 'computing' stamp: 'rkrk 9/20/2009 03:48'!
computeTimeForAllTestsFrom: timeForEachTest

	^ timeForEachTest values sum.! !

!ATddBenchmarker methodsFor: 'computing' stamp: 'rkrk 9/20/2009 18:06'!
computeTimeForEachTest

	| aTestRunner testClasses timeForEach |
	aTestRunner := CSTestRunner new.
	testClasses := self testClassesOfPackages.
	timeForEach := Dictionary new.
	testClasses
		do: [:testClass | 
			testClass selectors
				select: [:s | s isTestSelector]
				thenDo: [:s | | time |
					time := [aTestRunner runSuite: (testClass suiteWithSelectorsMatching: s)] timeToRun.
					timeForEach at: (testClass >> s) methodReference put: time]]
		displayingProgress: 'Running Tests (' , testClasses size asString, ' test classes)'.
	^ timeForEach! !

!ATddBenchmarker methodsFor: 'computing' stamp: 'rkrk 9/20/2009 18:11'!
computeTimeForEachTestClassFrom: timeForEachTest

	| timeForEach |
	timeForEach := Dictionary new.
	self testClassesOfPackages do: [:class | | methodsOfClass time |
		methodsOfClass := timeForEachTest keys select: [:m | m actualClass = class].
		time := methodsOfClass inject: 0 into: [:t :m | (timeForEachTest at: m) + t].
		timeForEach at: class put: time].
	^ timeForEach! !

!ATddBenchmarker methodsFor: 'derived accessing' stamp: 'rkrk 9/22/2009 14:43'!
coveringTestClassesTimeFor: appMethod from: timeForEachTestClass

	| testClasses |
	testClasses := (appMethod coveringTestMethods
		collect: [:ea | ea methodClass]
		thenSelect: [:ea | ea isObsolete not]) asSet.
	^ testClasses
		inject: 0
		into: [:sum :c | (timeForEachTestClass at: c) + sum].! !

!ATddBenchmarker methodsFor: 'derived accessing' stamp: 'rkrk 9/22/2009 14:43'!
coveringTestMethodsTimeFor: appMethod from: timeForEachTest

	^ appMethod coveringTestMethods
		inject: 0
		into: [:sum :m | (timeForEachTest at: m methodReference ifAbsent: [0"???"]) + sum].! !

!ATddBenchmarker methodsFor: 'running' stamp: 'rkrk 9/20/2009 18:17'!
measureCoveringTimesForPackages: packageString

	^ String streamContents: [:stream |
		self 
			measureCoveringTimesForPackages: packageString 
			printOn: stream].
	! !

!ATddBenchmarker methodsFor: 'running' stamp: 'rkrk 9/22/2009 14:44'!
measureCoveringTimesForPackages: packageString printOn: stream

	"^ #(coveringTestMethodsTime coveringTestClassesTime timeForRunningAllTestsAtEveryChange)"
	| timeForEachTest timeForEachTestClass timeForAllTests testClassesTimesPerMethod testTimesPerMethod coveredTestMethodsTimes coveredTestClassesTimes |
	packages := PackageOrganizer default packages select: [:p | p packageName startsWith: packageString].
	packages do: [:p | CSCoverageTracingWrapper registerPackage: p].

	timeForEachTest := self computeTimeForEachTest.
	timeForEachTestClass := self computeTimeForEachTestClassFrom: timeForEachTest.
	timeForAllTests := self computeTimeForAllTestsFrom: timeForEachTest.
	testTimesPerMethod := self computeTestTimesPerMethodFrom: timeForEachTest.
	testClassesTimesPerMethod := self computeTestClassesTimesPerMethodFrom: timeForEachTestClass.

	"CSV style output
	appMethods,coveredMethods,coveredTestMethodsTimes average, coveredTestMethodsTimes median, coveredTestMethodsTimes min, coveredTestMethodsTimes max, coveredTestMethodsTimes sum, coveredTestClassesTimes avg, coveredTestClassesTimes median, coveredTestClassesTimes sum, timeForAllTests, timeForAllTests sum"
	coveredTestMethodsTimes := testTimesPerMethod values.
	coveredTestClassesTimes := testClassesTimesPerMethod values.
	stream
		print: self appMethods size; nextPut: $,;
		print: (self methodsCovered: self appMethods) size; nextPut: $,;
		print: (coveredTestMethodsTimes average roundTo: 1); nextPut: $,;
		print: (coveredTestMethodsTimes median roundTo: 1); nextPut: $,;
		print: coveredTestMethodsTimes min; nextPut: $,;
		print: coveredTestMethodsTimes max; nextPut: $,;
		print: coveredTestMethodsTimes sum; nextPut: $,;
		print: (coveredTestClassesTimes average roundTo: 1); nextPut: $,;
		print: (coveredTestClassesTimes median roundTo: 1); nextPut: $,;
		print: coveredTestClassesTimes sum; nextPut: $,;
		print: timeForAllTests; nextPut: $,;
		print: (self methodsCovered: self methods) size * timeForAllTests;
		cr.
		
	packages do: [:p | CSCoverageTracingWrapper unregisterPackage: p].! !

!ATddBenchmarker methodsFor: 'running' stamp: 'bs 10/8/2009 16:10'!
measureTestExecutionTimeForPackages: packageString

	| aTestSuite testClasses nRuns |
	packages := PackageOrganizer default packages select: [:p | p packageName startsWith: packageString].
	"packages do: [:p | CSCoverageTracingWrapper registerPackage: p]."
	
	aTestSuite := TestSuite new.
	testClasses := self testClassesOfPackages.
	
	self testClassesOfPackages
		do: [:testClass | 
			testClass selectors
				select: [:s | s isTestSelector]
				thenDo: [:s | aTestSuite addTest: (testClass selector: s)]].
			
	nRuns := 2.
	^ ([nRuns timesRepeat: [CSTestRunner new runSuite: aTestSuite]] timeToRun / nRuns).
	! !

!ATddBenchmarker methodsFor: 'derived accessing' stamp: 'rkrk 9/22/2009 14:43'!
methods

	^ methods ifNil: [
		methods := self classesOfPackages gather: [:class |
			class methodDict values]].! !

!ATddBenchmarker methodsFor: 'derived accessing' stamp: 'rkrk 9/21/2009 04:16'!
methodsCovered: methodCol

	^ methodCol select: [:ea | ea hasCoveringTestMethods].! !

!ATddBenchmarker methodsFor: 'derived accessing' stamp: 'rkrk 9/22/2009 14:43'!
testClassesOfPackages

	^ self classesOfPackages select: [:class |
		class inheritsFrom: TestCase].! !

Object subclass: #ATddMCAnalyzer
	instanceVariableNames: 'inspector methodVersionResult doAfterGathering'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Analyzing'!

!ATddMCAnalyzer class methodsFor: 'service' stamp: 'rkrk 9/20/2009 00:57'!
printVersionDatesOfPackage: packageName inRepo: repo

	| instance dates |
	instance := self new.
	instance
		gatherVersionsOf: {packageName}
		in: repo
		thenDo: [:versionInfos |
			dates := (versionInfos collect: [:ea | ea date]) asSet.
			dates := dates	asOrderedCollection sortBy: [:a :b | a < b].
			Transcript cr; show: packageName; show: ' -- active development'.
			dates do: [:ea | Transcript cr; show: ea asString]].
	^instance.! !

!ATddMCAnalyzer methodsFor: 'as yet unclassified' stamp: 'rkrk 9/20/2009 00:23'!
gatherVersionsOf: packageNames in: mcRepository thenDo: block

	inspector ifNotNil: [inspector stop].
	inspector := XpfCtMczInspector
		newForPackagesNamed: packageNames
		inRepo: mcRepository.
	methodVersionResult := OrderedCollection new.
	inspector addDependent: self.
	inspector startInspectVersions.
	doAfterGathering := block.
	^ methodVersionResult! !

!ATddMCAnalyzer methodsFor: 'as yet unclassified' stamp: 'rkrk 9/19/2009 23:08'!
inspect: selector of: class in: packageName

	inspector ifNotNil: [inspector stop].
	inspector := XpfCtMczInspector newForPackageNamed: packageName.
	methodVersionResult := OrderedCollection new.
	inspector addDependent: self.
	inspector startInspectVersionsFor: selector in: class.
	^ methodVersionResult! !

!ATddMCAnalyzer methodsFor: 'nil' stamp: 'rkrk 9/20/2009 00:58'!
methodVersionResult

	^ methodVersionResult! !

!ATddMCAnalyzer methodsFor: 'as yet unclassified' stamp: 'rkrk 9/20/2009 00:24'!
update: aSymbol

	super update: aSymbol.
	aSymbol = #done ifFalse: [^ self].
	Transcript cr show: 'done'.
	doAfterGathering value: methodVersionResult.! !

!ATddMCAnalyzer methodsFor: 'as yet unclassified' stamp: 'rkrk 9/19/2009 23:13'!
update: aSymbol with: anObject

	super update: aSymbol with: anObject.
	aSymbol = #versionFound ifFalse: [^self].
	Transcript cr; show: 'Found ' , anObject asString.
	methodVersionResult add: anObject.! !

Object subclass: #ATddReceiverAnalyzer
	instanceVariableNames: 'stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Analyzing'!

!ATddReceiverAnalyzer methodsFor: 'analyzing' stamp: 'rkrk 10/7/2009 21:32'!
getClassOf: method

	^ method methodClass ifNil: [method searchForClass].! !

!ATddReceiverAnalyzer methodsFor: 'analyzing' stamp: 'rkrk 10/7/2009 21:38'!
init

	stream := WriteStream on: ''.! !

!ATddReceiverAnalyzer methodsFor: 'analyzing' stamp: 'rkrk 10/7/2009 21:29'!
isOverwritten: method

	"CompiledMethod>>overridingMethods does not work"
	^ (self overridingClasses: method) notEmpty! !

!ATddReceiverAnalyzer methodsFor: 'analyzing' stamp: 'rkrk 10/7/2009 21:35'!
methodsNotOverwrittenIn: package

	^ ((package coreMethods collect: [:ea | ea compiledMethod]
		thenSelect: [:method | method hasCoveringTestMethods])
		reject: [:method | self isOverwritten: method])
		reject: [:method | (self getClassOf: method) allSubclasses isEmpty].! !

!ATddReceiverAnalyzer methodsFor: 'analyzing' stamp: 'rkrk 10/7/2009 21:32'!
overridingClasses: method

	^ (self getClassOf: method) allSubclasses select: [:ea |
		ea includesSelector: method selector].! !

!ATddReceiverAnalyzer methodsFor: 'analyzing' stamp: 'rkrk 10/7/2009 22:29'!
printTestsForOverwrittenMethodsWithAndWithoutReceiverIn: package

	"self printTestsForOverwrittenMethodsWithAndWithoutReceiverIn:
		(PackageInfo named: 'AweSOM')"
	| methods
	appMethodClass pureTestCount testCountReceiver allNoRecv allRecv stat |
	self init.
	methods := self methodsNotOverwrittenIn: package.
	methods do: [:appMethod |
		appMethodClass := self getClassOf: appMethod.
		pureTestCount := appMethod coveringTestMethods size.
		allNoRecv := allRecv := 0.
		"<for each subclass>"
		appMethodClass allSubclasses do: [:subclass |
			testCountReceiver := 0.
			"<for each coveringTest>"
			"<if subclass or any of its subclasses are
			included in receiverclasses of coveringTest --> count+1>"
			testCountReceiver := appMethod coveringTestMethods count: [:test | 
				stat := test statisticsForCoveredMethod: appMethod clientMethod.
				(stat receiverClasses includesAnyOf: subclass withAllSubclasses)].
			"----"
			allNoRecv := allNoRecv + pureTestCount.
			allRecv := allRecv + testCountReceiver.
			"print it"
			stream
				cr; nextPutAll: 'If method '; nextPutAll: appMethod selector;
				nextPutAll: ' would be added to '; nextPutAll: subclass name; space;
				print: pureTestCount; nextPutAll: '/'; print: testCountReceiver;
				nextPutAll: ' should run.'.
		].
		"print it again"
		stream
			cr; print: allRecv; nextPut: $/; print: allNoRecv;
			nextPut: $=;
			print: (allRecv isZero
				ifTrue: [0]
				ifFalse: [allRecv / allNoRecv * 100 asFloat]).
		Transcript show: stream contents.
	].! !

Object subclass: #ATddVersionLoader
	instanceVariableNames: 'repo versionFileNames'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Analyzing'!

!ATddVersionLoader class methodsFor: 'as yet unclassified' stamp: 'rkrk 9/20/2009 02:42'!
loadVersionsNamed: versionNames from: mcRepository

	| fileNames |
	fileNames := versionNames collect: [:ea |
		(ea endsWith: '.mcz') ifTrue: [ea] ifFalse: [ea , '.mcz']].
	self new
		repo: mcRepository;
		versionFileNames: fileNames;
		loadAll;
		yourself.! !

!ATddVersionLoader methodsFor: 'as yet unclassified' stamp: 'rkrk 9/20/2009 02:46'!
loadAll

	| versions |
	versions := self versionFileNames collect: [:ea |
		repo loadVersionFromFileNamed: ea].
	versions do: [:ea | ea load].! !

!ATddVersionLoader methodsFor: 'as yet unclassified' stamp: 'rkrk 9/20/2009 02:42'!
repo: mcRepository

	repo := mcRepository! !

!ATddVersionLoader methodsFor: 'as yet unclassified' stamp: 'rkrk 9/20/2009 02:44'!
versionFileNames

	^ versionFileNames! !

!ATddVersionLoader methodsFor: 'as yet unclassified' stamp: 'rkrk 9/20/2009 02:43'!
versionFileNames: fileNames

	versionFileNames := fileNames! !

Object subclass: #CSExampleFooBar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Tests'!

!CSExampleFooBar methodsFor: 'as yet unclassified' stamp: 'bs 9/24/2009 08:20'!
fooBar! !

Object subclass: #CSExamplePerson
	instanceVariableNames: 'firstname'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Tests'!

!CSExamplePerson class methodsFor: 'as yet unclassified' stamp: 'bs 10/28/2009 09:24'!
wantsRecompilationProgressReported
	"turn off for this clas because it is modified during tests"

	^ false
! !

!CSExamplePerson methodsFor: 'as yet unclassified' stamp: 'test 10/28/2009 11:49'!
asString
	^ super asString! !

!CSExamplePerson methodsFor: 'as yet unclassified' stamp: 'test 10/28/2009 11:49'!
firstname
	^ firstname! !

!CSExamplePerson methodsFor: 'accessing' stamp: 'test 10/28/2009 11:49'!
firstname: anObject
	firstname := anObject! !

Object subclass: #CSExampleTrace
	instanceVariableNames: 'counter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Tests'!

!CSExampleTrace class methodsFor: 'accessing' stamp: 'mp 2/11/2009 17:22'!
traceRegistry

	^ CSTraceRegistry current! !

!CSExampleTrace methodsFor: 'testing' stamp: 'mp 2/11/2009 13:46'!
complexMethodCalls

	^ self loop + self incrementCounter + self squareCounter + self conditional! !

!CSExampleTrace methodsFor: 'testing' stamp: 'mp 2/9/2009 13:34'!
conditional

	^ self counter = 2
		ifTrue: [self squareCounter]
		ifFalse: [self incrementCounter]! !

!CSExampleTrace methodsFor: 'accessing' stamp: 'mp 2/9/2009 11:43'!
counter
	"Answer the value of counter"

	^ counter! !

!CSExampleTrace methodsFor: 'accessing' stamp: 'mp 2/9/2009 13:51'!
counter: anObject
	"Set the value of counter"

	counter := anObject! !

!CSExampleTrace methodsFor: 'testing' stamp: 'mp 2/9/2009 11:45'!
doNothing! !

!CSExampleTrace methodsFor: 'testing' stamp: 'mp 2/9/2009 11:46'!
incrementCounter

	self counter: self counter + 1.
	^ self counter! !

!CSExampleTrace methodsFor: 'initialize-release' stamp: 'mp 2/11/2009 18:08'!
initialize
	
	self counter: 0.
	self addDependent: self.! !

!CSExampleTrace methodsFor: 'testing' stamp: 'mp 2/9/2009 16:14'!
loop

	3 timesRepeat: [self incrementCounter].
	self squareCounter.
	^ self counter! !

!CSExampleTrace methodsFor: 'testing' stamp: 'mp 2/11/2009 18:09'!
observerCounter

	self incrementCounter.
	self changed.
	self incrementCounter.
	^ self counter! !

!CSExampleTrace methodsFor: 'initialize-release' stamp: 'mp 2/11/2009 10:25'!
reset

	self initialize.! !

!CSExampleTrace methodsFor: 'testing' stamp: 'mp 2/9/2009 13:30'!
squareCounter

	self counter: self counter squared.
	^ self counter! !

!CSExampleTrace methodsFor: 'testing' stamp: 'mp 2/13/2009 11:29'!
throwError

	[self error: 'Error'] ifError: [self incrementCounter].
	^ self counter

	! !

!CSExampleTrace methodsFor: 'testing' stamp: 'mp 2/11/2009 18:10'!
update: anObject

	self incrementCounter.! !

CSExampleTrace subclass: #CSSubExampleTrace
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Tests'!

!CSSubExampleTrace methodsFor: 'testing' stamp: 'mp 2/11/2009 17:50'!
incrementCounter
	
	super incrementCounter.
	self counter: self counter + 1.
	^ self counter! !

Object subclass: #CSRegisteredTrace
	instanceVariableNames: 'identifier timestamp startEntries returnValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Tracer'!

!CSRegisteredTrace class methodsFor: 'as yet unclassified' stamp: 'mp 2/10/2009 10:57'!
with: anIdentifier

	^ self new
		identifier: anIdentifier! !

!CSRegisteredTrace methodsFor: 'accessing' stamp: 'mp 2/5/2009 11:02'!
identifier
	"Answer the value of identifier"

	^ identifier! !

!CSRegisteredTrace methodsFor: 'accessing' stamp: 'mp 2/5/2009 11:02'!
identifier: anObject
	"Set the value of identifier"

	identifier := anObject! !

!CSRegisteredTrace methodsFor: 'initialize-release' stamp: 'mp 2/10/2009 10:57'!
initialize
	
	self 
		timestamp: DateAndTime now;
		startEntries: OrderedCollection new.! !

!CSRegisteredTrace methodsFor: 'accessing' stamp: 'mp 2/7/2009 16:38'!
returnValue
	"Answer the value of returnValue"

	^ returnValue! !

!CSRegisteredTrace methodsFor: 'accessing' stamp: 'mp 2/7/2009 16:38'!
returnValue: anObject
	"Set the value of returnValue"

	returnValue := anObject! !

!CSRegisteredTrace methodsFor: 'accessing' stamp: 'mp 2/6/2009 15:16'!
startEntries
	"Answer the value of startEntries"

	^ startEntries! !

!CSRegisteredTrace methodsFor: 'accessing' stamp: 'mp 2/6/2009 15:16'!
startEntries: anObject
	"Set the value of startEntries"

	startEntries := anObject! !

!CSRegisteredTrace methodsFor: 'accessing' stamp: 'mp 2/5/2009 11:02'!
timestamp
	"Answer the value of timestamp"

	^ timestamp! !

!CSRegisteredTrace methodsFor: 'accessing' stamp: 'mp 2/5/2009 11:02'!
timestamp: anObject
	"Set the value of timestamp"

	timestamp := anObject! !

Object subclass: #CSStepper
	instanceVariableNames: 'blockToExecute'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-TestTracer'!

!CSStepper methodsFor: 'as yet unclassified' stamp: 'bs 4/16/2009 12:01'!
executeInNextStep: aBlock
	blockToExecute := aBlock.
	ActiveWorld startStepping: self at: Time millisecondClockValue selector: #step arguments: nil stepTime: nil.! !

!CSStepper methodsFor: 'as yet unclassified' stamp: 'bs 4/16/2009 12:02'!
shouldGetStepsFrom: aWorld
	^ActiveWorld == aWorld! !

!CSStepper methodsFor: 'as yet unclassified' stamp: 'bs 4/16/2009 12:01'!
step
	blockToExecute value.
	ActiveWorld stopStepping: self selector: #step.! !

Object subclass: #CSTestStatistic
	instanceVariableNames: 'maxTraceDepth minTraceDepth numCalls receiverClasses'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-TestTracer'!

!CSTestStatistic class methodsFor: 'as yet unclassified' stamp: 'bs 4/30/2009 17:27'!
generateStatistics
	" 'all: 1149; coveredMethods: 634; directlyCoveredMethods: 174'"
	"  'all: 403; coveredMethods: 330; directlyCoveredMethods: 134'"
	"seaside 'all: 2478; coveredMethods: 534; directlyCoveredMethods: 123'"
	| classes methods coveredMethods directlyCoveredMethods loc |
	classes := CSTraceChooser allClasses reject: [:c | c inheritsFrom: TestCase].

	methods := Set new.
	classes do: [:c | methods addAll: c methodDict values].

	coveredMethods := methods select: [:m | m hasCoveringTestMethods].
	directlyCoveredMethods := (coveredMethods select: [:m | (m coveringTestMethods select: [:tm | (tm statisticsForCoveredMethod: m) minTraceDepth == 1]) size > 0 ]).
	
	loc := (classes collect: [:c | c linesOfCode ]) sum.

	^ 'all: ', methods size asString, '; coveredMethods: ', coveredMethods size asString, '; directlyCoveredMethods: ', directlyCoveredMethods size asString, '; loc: ', loc asString.! !

!CSTestStatistic methodsFor: 'initialize-release' stamp: 'rkrk 10/6/2009 14:36'!
addCallInDepth: aNumber
	
	self flag: #rkrk. "for benchmarking"
	(self numCalls = 0) 
		ifTrue: [
			self numCalls: 1.
			self minTraceDepth: aNumber.
			self maxTraceDepth: aNumber]
		ifFalse: [
			self numCalls: self numCalls + 1.
	
			(self minTraceDepth > aNumber) 
				ifTrue: [self minTraceDepth: aNumber].
	
			(self maxTraceDepth < aNumber) 
				ifTrue: [self maxTraceDepth: aNumber].
			].! !

!CSTestStatistic methodsFor: 'public' stamp: 'bs 9/30/2009 16:22'!
addCallInDepth: aNumber receiver: anObject
	self receiverClasses add: anObject class.
	
	(self numCalls = 0) 
		ifTrue: [
			self numCalls: 1.
			self minTraceDepth: aNumber.
			self maxTraceDepth: aNumber]
		ifFalse: [
			self numCalls: self numCalls + 1.
	
			(self minTraceDepth > aNumber) 
				ifTrue: [self minTraceDepth: aNumber].
	
			(self maxTraceDepth < aNumber) 
				ifTrue: [self maxTraceDepth: aNumber].
			].! !

!CSTestStatistic methodsFor: 'accessing' stamp: 'bs 9/16/2009 21:13'!
asString
	^ self class name, ': numCalls: ', self numCalls asString, '; minTraceDepth: ', self minTraceDepth asString, '; maxTraceDepth: ', self maxTraceDepth asString! !

!CSTestStatistic methodsFor: 'initialize-release' stamp: 'bs 4/30/2009 15:59'!
initialize
	maxTraceDepth := 0.
	minTraceDepth := 0.
	numCalls := 0.! !

!CSTestStatistic methodsFor: 'accessing' stamp: 'mab 4/9/2009 12:53'!
maxTraceDepth
	^ maxTraceDepth! !

!CSTestStatistic methodsFor: 'accessing' stamp: 'bs 4/30/2009 10:39'!
maxTraceDepth: anObject
	maxTraceDepth := anObject! !

!CSTestStatistic methodsFor: 'accessing' stamp: 'bs 4/30/2009 10:36'!
minTraceDepth
	^ minTraceDepth! !

!CSTestStatistic methodsFor: 'accessing' stamp: 'bs 4/30/2009 10:40'!
minTraceDepth: anObject
	minTraceDepth := anObject! !

!CSTestStatistic methodsFor: 'accessing' stamp: 'mab 4/9/2009 12:52'!
numCalls
	^ numCalls! !

!CSTestStatistic methodsFor: 'accessing' stamp: 'mab 4/9/2009 12:52'!
numCalls: anInteger
	numCalls := anInteger! !

!CSTestStatistic methodsFor: 'as yet unclassified' stamp: 'rkrk 10/7/2009 10:51'!
printOn: stream

	stream
		nextPutAll: 'CSTestStatistic<Trace:';
		print: self minTraceDepth;
		nextPut: $-;
		print: self maxTraceDepth;
		nextPut: $|;
		nextPutAll: 'Calls:';
		print: self numCalls;
		nextPut: $|;
		nextPutAll: 'Receivers:';
		print: self receiverClasses;
		nextPut: $>.! !

!CSTestStatistic methodsFor: 'accessing' stamp: 'bs 9/30/2009 16:17'!
receiverClasses
	^ receiverClasses ifNil: [receiverClasses := IdentitySet new]! !

Object subclass: #CSTraceChooser
	instanceVariableNames: 'list listSelections'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-TestTracer'!

!CSTraceChooser class methodsFor: 'as yet unclassified' stamp: 'bs 9/4/2009 14:40'!
allClasses
	| set |
	set := Set new.
	CSCoverageTracingWrapper registeredPackages do: [ :aPackage |
		set addAll: aPackage classes ].
	^ set! !

!CSTraceChooser class methodsFor: 'as yet unclassified' stamp: 'mab 4/1/2009 19:11'!
build
	^ ToolBuilder build: self new! !

!CSTraceChooser class methodsFor: 'as yet unclassified' stamp: 'mab 4/1/2009 19:07'!
initialize
	"CSTraceChooser initialize"
	self registerInToolsFlap! !

!CSTraceChooser class methodsFor: 'as yet unclassified' stamp: 'mab 4/3/2009 15:31'!
open
	^ ToolBuilder open: self new! !

!CSTraceChooser class methodsFor: 'as yet unclassified' stamp: 'mab 4/2/2009 18:52'!
packages
	^ Packages ifNil: [ Packages := Set new ]! !

!CSTraceChooser class methodsFor: 'as yet unclassified' stamp: 'mab 4/1/2009 19:12'!
registerInToolsFlap
	self environment at: #Flaps ifPresent: [ :class |
		class
			registerQuad: #( CSTraceChooser build 'Test Traces' 'Choose your packages for test tracing.' ) forFlapNamed: 'Tools';
			replaceToolsFlap ].! !

!CSTraceChooser methodsFor: 'as yet unclassified' stamp: 'bs 9/4/2009 15:51'!
buildWith: builder
	| windowSpec listSpec buttonSpec |
	windowSpec := builder pluggableWindowSpec new.
	windowSpec 
		model: self;
		label: 'Test Trace Chooser';
		children: OrderedCollection new;
		closeAction: #close.
		
	listSpec := builder pluggableMultiSelectionListSpec new.
	listSpec 
		model: self;
		list: #list;
		getSelectionList: #listSelectionAt:;
		setSelectionList: #listSelectionAt:put:;
		frame: (0@0corner: 1@0.8).
	windowSpec children add: listSpec.
	
	buttonSpec := builder pluggableButtonSpec new.
	buttonSpec
		model: self;
		label: 'Refresh';
		action: #refresh;
		frame: (0@0.8 corner: 1@1).
	windowSpec children add: buttonSpec.
	
	^builder build: windowSpec! !

!CSTraceChooser methodsFor: 'as yet unclassified' stamp: 'bs 9/4/2009 15:48'!
close! !

!CSTraceChooser methodsFor: 'as yet unclassified' stamp: 'bs 9/24/2009 08:29'!
list
	^ list ifNil: [ list := self packageNamesSorted ]! !

!CSTraceChooser methodsFor: 'as yet unclassified' stamp: 'mab 4/1/2009 18:07'!
listSelectionAt: index
	^ self listSelections at: index! !

!CSTraceChooser methodsFor: 'as yet unclassified' stamp: 'bs 9/4/2009 15:14'!
listSelectionAt: index put: isSelected
	
	isSelected 
		ifTrue: [self registerPackage: (self packageAt: index).]
		ifFalse: [self unregisterPackage: (self packageAt: index) ].
	
	^ self listSelections at: index put: isSelected! !

!CSTraceChooser methodsFor: 'as yet unclassified' stamp: 'bs 9/4/2009 15:14'!
listSelections
	listSelections ifNil: [
		self list ifNotNil: [
			listSelections := Array new: self list size withAll: false.
			self list doWithIndex: [ :each :index |
				(self registeredPackages includes: each) ifTrue: [
					listSelections at: index put: true ]]]].
	^ listSelections! !

!CSTraceChooser methodsFor: 'as yet unclassified' stamp: 'bs 9/4/2009 15:11'!
packageAt: index
	| packageName |
	packageName := self list at: index.
	^ self packageNamed: packageName! !

!CSTraceChooser methodsFor: 'as yet unclassified' stamp: 'bs 9/4/2009 15:10'!
packageNamed: aName
	^ PackageOrganizer default packageNamed: aName ifAbsent: [].! !

!CSTraceChooser methodsFor: 'as yet unclassified' stamp: 'bs 9/24/2009 08:36'!
packageNamesSorted
	| packageNames criticalPackages |
	packageNames := PackageOrganizer default packages 
			collect: [ :packageInfo | packageInfo packageName ].
	
	criticalPackages := {'Collections'. 'CollectionsTests'.
								'Kernel'. 'KernelTests'.
								'Graphics'. 'GraphicsTests'.
								'ST80'. 'SUnit'. 'System' }.
	^ (packageNames reject: [:package | 
			criticalPackages anySatisfy: [:critical | 
				critical = package] ]) sort! !

!CSTraceChooser methodsFor: 'as yet unclassified' stamp: 'bs 9/4/2009 15:51'!
refresh
	list := nil.
	listSelections := nil.! !

!CSTraceChooser methodsFor: 'as yet unclassified' stamp: 'bs 9/4/2009 15:14'!
registerPackage: aPackage
	^ CSCoverageTracingWrapper registerPackage: aPackage! !

!CSTraceChooser methodsFor: 'as yet unclassified' stamp: 'bs 9/4/2009 15:13'!
registeredPackages
	^ CSCoverageTracingWrapper registeredPackages! !

!CSTraceChooser methodsFor: 'as yet unclassified' stamp: 'bs 9/4/2009 15:14'!
unregisterPackage: aPackage
	^ CSCoverageTracingWrapper unregisterPackage: aPackage! !

Object subclass: #CSTraceEntry
	instanceVariableNames: 'methodClass methodSelector depth'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Tracer'!

CSTraceEntry subclass: #CSTraceCallEntry
	instanceVariableNames: 'receiver arguments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Tracer'!

!CSTraceCallEntry methodsFor: 'accessing' stamp: 'mp 2/4/2009 17:53'!
arguments
	"Answer the value of arguments"

	^ arguments! !

!CSTraceCallEntry methodsFor: 'accessing' stamp: 'mp 2/4/2009 17:53'!
arguments: anObject
	"Set the value of arguments"

	arguments := anObject! !

!CSTraceCallEntry methodsFor: 'iterating' stamp: 'mp 2/8/2009 12:18'!
getNextMethodPropertiesFor: anIdentifier

	^ (self methodClass methodDict at: self methodSelector) 
		properties at: anIdentifier! !

!CSTraceCallEntry methodsFor: 'testing' stamp: 'mp 2/4/2009 17:56'!
isCall

	^ true! !

!CSTraceCallEntry methodsFor: 'iterating' stamp: 'mp 2/9/2009 15:55'!
iterateNextMethodTrace: anIdentifier	withNextCallBlock: aCallBlock andReturnBlock: aReturnBlock
	
	(self getNextMethodPropertiesFor: anIdentifier)	
		do: [:each | 
			each
				predecessor: self
				ifNextCall: aCallBlock
				ifReturn: aReturnBlock]! !

!CSTraceCallEntry methodsFor: 'testing' stamp: 'mp 2/10/2009 10:48'!
predecessor: aCallEntry ifNextCall: aCallBlock ifReturn: aReturnBlock
	
	(self depth size = (aCallEntry depth size + 1) and: [self depth beginsWith: aCallEntry depth])
		ifTrue: [aCallBlock value: self].! !

!CSTraceCallEntry methodsFor: 'accessing' stamp: 'mp 2/4/2009 17:53'!
receiver
	"Answer the value of receiver"

	^ receiver! !

!CSTraceCallEntry methodsFor: 'accessing' stamp: 'mp 2/4/2009 17:53'!
receiver: anObject
	"Set the value of receiver"

	receiver := anObject! !

!CSTraceEntry methodsFor: 'accessing' stamp: 'mp 2/4/2009 18:21'!
depth
	"Answer the value of depth"

	^ depth! !

!CSTraceEntry methodsFor: 'accessing' stamp: 'mp 2/4/2009 18:21'!
depth: anObject
	"Set the value of depth"

	depth := anObject! !

!CSTraceEntry methodsFor: 'initialize-release' stamp: 'mp 2/11/2009 13:01'!
initialize

	self depth: OrderedCollection new.! !

!CSTraceEntry methodsFor: 'testing' stamp: 'mp 2/4/2009 17:56'!
isCall
	
	^ false! !

!CSTraceEntry methodsFor: 'testing' stamp: 'mp 2/4/2009 17:56'!
isReturn

	^ false! !

!CSTraceEntry methodsFor: 'accessing' stamp: 'mp 2/13/2009 13:24'!
methodClass
	"Answer the value of methodClass"

	^ methodClass! !

!CSTraceEntry methodsFor: 'accessing' stamp: 'mp 2/13/2009 13:24'!
methodClass: anObject
	"Set the value of methodClass"

	methodClass := anObject! !

!CSTraceEntry methodsFor: 'accessing' stamp: 'mp 2/13/2009 13:24'!
methodSelector
	"Answer the value of methodSelector"

	^ methodSelector! !

!CSTraceEntry methodsFor: 'accessing' stamp: 'mp 2/13/2009 13:24'!
methodSelector: anObject
	"Set the value of methodSelector"

	methodSelector := anObject! !

!CSTraceEntry methodsFor: 'testing' stamp: 'mp 2/8/2009 12:42'!
predecessor: aCallEntry ifNextCall: aCallBlock ifReturn: aReturnBlock

	self subclassResponsibility.! !

CSTraceEntry subclass: #CSTraceReturnEntry
	instanceVariableNames: 'returnValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Tracer'!

!CSTraceReturnEntry methodsFor: 'testing' stamp: 'mp 2/4/2009 17:56'!
isReturn

	^ true! !

!CSTraceReturnEntry methodsFor: 'testing' stamp: 'mp 2/9/2009 15:55'!
predecessor: aCallEntry ifNextCall: aCallBlock ifReturn: aReturnBlock

	self depth = aCallEntry depth
		ifTrue: [aReturnBlock value: self].! !

!CSTraceReturnEntry methodsFor: 'accessing' stamp: 'mp 2/4/2009 17:54'!
returnValue
	"Answer the value of returnValue"

	^ returnValue! !

!CSTraceReturnEntry methodsFor: 'accessing' stamp: 'mp 2/4/2009 17:54'!
returnValue: anObject
	"Set the value of returnValue"

	returnValue := anObject! !

Object subclass: #CSTraceRegistry
	instanceVariableNames: 'traces'
	classVariableNames: 'UniqueInstance'
	poolDictionaries: ''
	category: 'CodeSight-Tracer'!

!CSTraceRegistry class methodsFor: 'queries' stamp: 'mp 2/13/2009 11:24'!
cleanAllAnnotations

	CSTraceRegistry current traces keys do: [:key | self cleanAnnotationsFor: key].
	CSTraceRegistry current initialize.
	Smalltalk garbageCollect.! !

!CSTraceRegistry class methodsFor: 'queries' stamp: 'mp 2/13/2009 11:25'!
cleanAnnotationsFor: anIdentifier

	Smalltalk do: [:each | 
		[each methodDict 
			do: [:method | [method properties removeKey: anIdentifier] ifError: []].
		each class methodDict 
			do: [:method | [method properties removeKey: anIdentifier] ifError: []]]
		ifError: []].
	[CSTraceRegistry current traces removeKey: anIdentifier] ifError: [].! !

!CSTraceRegistry class methodsFor: 'instance creation' stamp: 'mp 2/5/2009 10:14'!
current

	UniqueInstance ifNil: [UniqueInstance := self basicNew initialize].
	^ UniqueInstance! !

!CSTraceRegistry class methodsFor: 'instance creation' stamp: 'mp 2/5/2009 10:12'!
new

	self error: 'Use current to get an instance of Class ' , self name.! !

!CSTraceRegistry methodsFor: 'tracing' stamp: 'mp 2/10/2009 10:56'!
addNewTrace: anIdentifier

	self traces 
		at: anIdentifier ifPresent: [:each | self error: 'Trace key already exist.'];
		at: anIdentifier put: (CSRegisteredTrace with: anIdentifier).
! !

!CSTraceRegistry methodsFor: 'tracing' stamp: 'mp 2/7/2009 16:39'!
at: anIdentifier putReturnValue: anObject

	(self traces at: anIdentifier) returnValue: anObject.! !

!CSTraceRegistry methodsFor: 'tracing' stamp: 'mp 2/6/2009 15:18'!
at: anIdentifier putStartEntry: aTraceEntry

	(self traces at: anIdentifier) startEntries addLast: aTraceEntry.! !

!CSTraceRegistry methodsFor: 'initialize-release' stamp: 'mp 2/5/2009 10:14'!
initialize

	self traces: IdentityDictionary new.! !

!CSTraceRegistry methodsFor: 'printing' stamp: 'mp 2/8/2009 13:05'!
printCall: aCallEntry forTrace: anIdentifier on: aStream

	self printCallEntry: aCallEntry on: aStream.	
	aCallEntry 
		iterateNextMethodTrace: anIdentifier
		withNextCallBlock: [:call | 
			self printCall: call forTrace: anIdentifier on: aStream] 
		andReturnBlock: [:return | 
			self printReturnEntry: return on: aStream].! !

!CSTraceRegistry methodsFor: 'printing' stamp: 'mp 2/8/2009 11:56'!
printCallEntry: aCallEntry on: aStream
			
	aStream cr.
	aCallEntry depth size timesRepeat: [aStream space].
	aStream	
		nextPutAll: aCallEntry methodClass asString;
		nextPutAll: '>>#';
		nextPutAll: aCallEntry methodSelector asString.! !

!CSTraceRegistry methodsFor: 'printing' stamp: 'mp 2/8/2009 13:05'!
printReturnEntry: aReturnEntry on: aStream

	aStream cr.
	aReturnEntry depth size timesRepeat: [aStream space].
	aStream
		nextPut: $^;	
		nextPutAll: aReturnEntry returnValue asString.

	! !

!CSTraceRegistry methodsFor: 'printing' stamp: 'mp 2/8/2009 11:52'!
printTrace: anIdentifier
		
	self printTrace: anIdentifier on: Transcript.
	! !

!CSTraceRegistry methodsFor: 'printing' stamp: 'mp 2/8/2009 12:01'!
printTrace: anIdentifier on: aStream
		
	self 
		printTraceIdentifier: anIdentifier on: aStream;
		printTraceStartEntries: anIdentifier on: aStream;
		printTraceResult: anIdentifier on: aStream.
	aStream flush.
	! !

!CSTraceRegistry methodsFor: 'printing' stamp: 'mp 2/8/2009 11:53'!
printTraceIdentifier: anIdentifier on: aStream

	aStream 
		cr;
		nextPut: $#;
		nextPutAll: anIdentifier asString.! !

!CSTraceRegistry methodsFor: 'printing' stamp: 'mp 2/8/2009 18:40'!
printTraceResult: anIdentifier on: aStream

	aStream 
		cr;
		nextPut: $^; 
		nextPutAll: (self traces at: anIdentifier) returnValue returnValue asString.! !

!CSTraceRegistry methodsFor: 'printing' stamp: 'mp 2/8/2009 11:55'!
printTraceStartEntries: anIdentifier on: aStream
	
	(self traces at: anIdentifier) startEntries do: [:each | 
		each isCall 
			ifTrue: [self printCall: each forTrace: anIdentifier on: aStream]
			ifFalse: [self error: 'Should not be possible. Trace is corrupted.']].! !

!CSTraceRegistry methodsFor: 'as yet unclassified' stamp: 'mp 2/8/2009 14:14'!
removeCall: aCallEntry forTrace: anIdentifier

	aCallEntry
		iterateNextMethodTrace: anIdentifier
		withNextCallBlock: [:call | 
			self removeCall: call forTrace: anIdentifier] 
		andReturnBlock: [:return | 
			((aCallEntry getNextMethodPropertiesFor: anIdentifier) last == return)
				ifTrue: [self removeData: aCallEntry fromTrace: anIdentifier]].	! !

!CSTraceRegistry methodsFor: 'as yet unclassified' stamp: 'mp 2/8/2009 14:16'!
removeData: aCallEntry fromTrace: anIdentifier

	(aCallEntry methodClass methodDict at: aCallEntry methodSelector) 
		properties removeKey: anIdentifier.! !

!CSTraceRegistry methodsFor: 'as yet unclassified' stamp: 'mp 2/8/2009 15:24'!
removeTrace: anIdentifier

	(self traces at: anIdentifier) startEntries do: [:each | 
		each isCall 
			ifTrue: [self removeCall: each forTrace: anIdentifier]
			ifFalse: [self error: 'Should not be possible. Trace is corrupted.']].
	self traces removeKey: anIdentifier.! !

!CSTraceRegistry methodsFor: 'accessing' stamp: 'mp 2/5/2009 10:14'!
traces
	"Answer the value of traces"

	^ traces! !

!CSTraceRegistry methodsFor: 'accessing' stamp: 'mp 2/5/2009 10:14'!
traces: anObject
	"Set the value of traces"

	traces := anObject! !

Object subclass: #CSTracer
	instanceVariableNames: 'identifier traceBlock depth currentDepth printFlag'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Tracer'!

!CSTracer class methodsFor: 'initialization' stamp: 'mp 2/10/2009 12:40'!
identifier: aSymbol
	
	^ self new
		identifier: aSymbol! !

!CSTracer methodsFor: 'private-adding' stamp: 'mp 2/7/2009 16:32'!
addCallFrom: aCurrentContext to: aPrevContext

	| entry |
	entry := self getCallEntry: aCurrentContext.
	aPrevContext == self traceBlock
		ifTrue: [self registry 
					at: self identifier 
					putStartEntry: entry]
		ifFalse: [self addEntry: entry to: aPrevContext].	! !

!CSTracer methodsFor: 'private-adding' stamp: 'test 9/17/2009 23:18'!
addEntry: entry to: aPrevContext

	| entries |
	entries := aPrevContext method properties 
				at: self identifier 
				ifAbsent: [OrderedCollection new].
	aPrevContext method properties 
		at: self identifier 
		put: (entries addLast: entry; yourself).! !

!CSTracer methodsFor: 'private-adding' stamp: 'mp 2/13/2009 13:39'!
addReturnFrom: aCurrentContext to: aPrevContext

	| entry |
	entry := self getReturnEntry: aCurrentContext.
	self addEntry: entry to: aPrevContext.! !

!CSTracer methodsFor: 'private-tracing' stamp: 'mp 2/7/2009 17:41'!
categoriesFromReceiver: anObject

	| receiverClass |
	receiverClass := anObject class.
	receiverClass isMeta
		ifTrue: [receiverClass := anObject].
	^ receiverClass category! !

!CSTracer methodsFor: 'accessing' stamp: 'mp 2/6/2009 14:07'!
currentDepth
	"Answer the value of currentDepth"

	^ currentDepth! !

!CSTracer methodsFor: 'accessing' stamp: 'mp 2/6/2009 14:07'!
currentDepth: anObject
	"Set the value of currentDepth"

	currentDepth := anObject! !

!CSTracer methodsFor: 'accessing' stamp: 'mp 2/6/2009 10:06'!
depth
	"Answer the value of depth"

	^ depth! !

!CSTracer methodsFor: 'accessing' stamp: 'mp 2/6/2009 10:06'!
depth: anObject
	"Set the value of depth"

	depth := anObject! !

!CSTracer methodsFor: 'private-adding' stamp: 'mp 2/7/2009 16:13'!
getCallEntry: aContext
							
	^ CSTraceCallEntry new
		depth: self depth veryDeepCopy;
		methodClass: aContext methodClass;
		methodSelector: aContext selector;
		"receiver: aContext receiver printString;"
		yourself! !

!CSTracer methodsFor: 'private-adding' stamp: 'mp 2/13/2009 18:16'!
getReturnEntry: aContext

	^ CSTraceReturnEntry new
		depth: self depth veryDeepCopy;
		returnValue: aContext top veryDeepCopy;
		methodClass: aContext methodClass;
		methodSelector: aContext selector;
		yourself! !

!CSTracer methodsFor: 'accessing' stamp: 'mp 2/4/2009 17:58'!
identifier
	"Answer the value of identifier"

	^ identifier! !

!CSTracer methodsFor: 'accessing' stamp: 'mp 2/4/2009 17:58'!
identifier: anObject
	"Set the value of identifier"

	identifier := anObject! !

!CSTracer methodsFor: 'private-depth' stamp: 'mp 2/6/2009 14:16'!
increaseDepth
		
	| entry |
	entry := self depth at: self currentDepth ifAbsent: nil.
	entry
		ifNil: [self depth at: self currentDepth ifAbsentPut: 1]
		ifNotNil: [self depth at: self currentDepth put: entry + 1].! !

!CSTracer methodsFor: 'initialize-release' stamp: 'mp 2/11/2009 14:43'!
initialize
	
	self 
		identifier: DateAndTime now asString asSymbol;
		depth: OrderedCollection new;
		printFlag: false.! !

!CSTracer methodsFor: 'private-printing' stamp: 'mp 2/11/2009 14:44'!
printCallFrom: aContext

	self printFlag 
		ifTrue:[
			Transcript cr.
			self currentDepth timesRepeat: [Transcript space].
			Transcript 
				nextPutAll: aContext receiver printString;
				space; 
				nextPutAll: aContext selector; 
				space; 
				nextPutAll: self depth asString; 
				flush].! !

!CSTracer methodsFor: 'accessing' stamp: 'mp 2/11/2009 14:43'!
printFlag
	"Answer the value of printFlag"

	^ printFlag! !

!CSTracer methodsFor: 'accessing' stamp: 'mp 2/11/2009 14:43'!
printFlag: anObject
	"Set the value of printFlag"

	printFlag := anObject! !

!CSTracer methodsFor: 'private-printing' stamp: 'mp 2/11/2009 14:45'!
printReturnFrom: aContext

	self printFlag 
		ifTrue:[
			Transcript cr.
			self currentDepth timesRepeat: [Transcript space].
			Transcript 
				space; 
				nextPut: $^;
				nextPutAll: aContext top printString;
				space; 
				nextPutAll: self depth asString;
				flush].! !

!CSTracer methodsFor: 'private-depth' stamp: 'mp 2/6/2009 14:15'!
reduceDepth

	self depth size = (self currentDepth + 2)
		ifTrue: [self depth removeLast.].! !

!CSTracer methodsFor: 'private-adding' stamp: 'mp 2/10/2009 10:56'!
registerTrace

	self registry addNewTrace: self identifier.! !

!CSTracer methodsFor: 'accessing' stamp: 'mp 2/5/2009 11:09'!
registry
	
	^ CSTraceRegistry current! !

!CSTracer methodsFor: 'tracing' stamp: 'mp 2/11/2009 14:49'!
trace: aBlock

	| previousContext result |
	self 
		registerTrace;
		traceBlock: aBlock.
	previousContext := self traceBlock.
	result := thisContext sender
		runSimulated: self traceBlock
		contextAtEachStep:
			[:currentContext |
			"Sensor anyButtonPressed ifTrue: [^ nil]."
			currentContext == previousContext
				ifFalse:
					[previousContext := self traceWith: currentContext and: previousContext]].
		self registry 
			at: self identifier 
			putReturnValue: (CSTraceReturnEntry new
								returnValue: result).
		^ result! !

!CSTracer methodsFor: 'accessing' stamp: 'mp 2/5/2009 11:28'!
traceBlock
	"Answer the value of traceBlock"

	^ traceBlock! !

!CSTracer methodsFor: 'accessing' stamp: 'mp 2/5/2009 11:28'!
traceBlock: anObject
	"Set the value of traceBlock"

	traceBlock := anObject! !

!CSTracer methodsFor: 'private-tracing' stamp: 'mp 2/7/2009 18:12'!
traceMethodCallWith: aCurrentContext and: aPreviousContext
	
	self 
		increaseDepth;
		addCallFrom: aCurrentContext to: aPreviousContext;
		printCallFrom: aCurrentContext.! !

!CSTracer methodsFor: 'private-tracing' stamp: 'mp 2/7/2009 18:12'!
traceReturnWith: aCurrentContext and: aPreviousContext
	
	self 
		reduceDepth;
		addReturnFrom: aCurrentContext to: aPreviousContext;
		printReturnFrom: aCurrentContext.! !

!CSTracer methodsFor: 'private-tracing' stamp: 'mp 2/10/2009 10:48'!
traceWith: aCurrentContext and: aPreviousContext

	self currentDepth: (aCurrentContext depthBelow: self traceBlock).
	aPreviousContext sender
		ifNil: [self traceReturnWith: aCurrentContext and: aPreviousContext]
		ifNotNil: [self traceMethodCallWith: aCurrentContext and: aPreviousContext].
	^ aCurrentContext! !

!Object methodsFor: '*codesight' stamp: 'bs 4/28/2009 18:20'!
debugAndUninstallBreakpointBefore
	(Debugger context: thisContext)
		debug: 'Debugger' executeBefore: [:debugger | 
			debugger down.
			BreakpointManager unInstall: debugger selectedContext method.
			debugger restartAfterMethodChanged.].
	Processor activeProcess suspend.! !

!OBClassNode methodsFor: '*codesight' stamp: 'rkrk 9/22/2009 01:06'!
backgroundColor

	(CSCoverageTracingWrapper registeredClasses includes: theClass)
		ifFalse: [^ super backgroundColor].
	theClass methodDict values do: [:method |
		(method hasCoveringTestMethods
			or: [method selector isTestSelector
				and: [theClass inheritsFrom: TestCase]])
					ifFalse: [^ Color lightOrange]].
	^ super backgroundColor.! !

!Debugger methodsFor: '*codesight' stamp: 'bs 4/16/2009 12:06'!
debug: label executeBefore: aBlock
	"Open a full DebuggerView."
	Smalltalk isMorphic
		ifTrue:
			[self openFullMorphicLabel: label.
			 CSStepper new executeInNextStep: [aBlock value: self].
			 errorWasInUIProcess := Project spawnNewProcessIfThisIsUI: interruptedProcess.
			 ^self].
! !

!Debugger methodsFor: '*codesight' stamp: 'bs 4/16/2009 11:16'!
restartAfterMethodChanged 
	"The retrieved information has changed and its source must now be  
	updated. In this case, the retrieved information is the method of the  
	selected context."
	| selector classOfMethod category h ctxt |
	
	h := self selectedContext finalBlockHome.
	self resetContext: h.
	classOfMethod := self selectedClass.
	category := self selectedMessageCategoryName.
	selector := self selectedMessageName.
	
	contents := classOfMethod sourceCodeAt: selector.
	ctxt := interruptedProcess popTo: self selectedContext.
	interruptedProcess suspendedContext privRefreshWith: (classOfMethod compiledMethodAt: selector).
	"interruptedProcess
		restartTopWith: (classOfMethod compiledMethodAt: selector)."
	contextVariablesInspector object: nil.
	theMethodNode := Preferences browseWithPrettyPrint
		ifTrue: [ctxt methodNodeFormattedAndDecorated: Preferences colorWhenPrettyPrinting]
		ifFalse: [ctxt methodNode].
	sourceMap := theMethodNode sourceMap.
	tempNames := theMethodNode tempNames.
		
	self resetContext: ctxt.
	self changed.
	^ true! !

!OBMethodNode methodsFor: '*codesight' stamp: 'rkrk 9/21/2009 23:34'!
backgroundColor

	((CSCoverageTracingWrapper registeredClasses includes: theClass) not
		or: [selector isTestSelector]
		or: [(theClass includesSelector: selector) not]
		or: [(theClass compiledMethodAt: selector) hasCoveringTestMethods])
			ifTrue: [^ super backgroundColor].
	^ Color lightOrange.! !

!OBMethodNode methodsFor: '*codesight' stamp: 'bs 5/4/2009 21:53'!
compiledMethod
	^ theClass compiledMethodAt: self selector! !

!OBMethodNode methodsFor: '*codesight' stamp: 'bs 10/7/2009 10:34'!
coveringTestMethods

	| testMethodNodes theMethod statistics node createAndAddCoveringNode |
	testMethodNodes := OrderedCollection new.
	(theClass includesSelector: selector) ifTrue: [
		theMethod := self compiledMethod.
		createAndAddCoveringNode := [:testMethod | 
			statistics := testMethod statisticsForCoveredMethod: theMethod unwrappedMethod.
			node := OBCoveringTestCaseNode on: testMethod 
							statistic: statistics coveredMethodNode: self.
			testMethodNodes add: node ].
		
		"theMethod fixedTestMethods do: createAndAddCoveringNode.
		
		node := OBCoveringTestCaseSeparatorNode coveredMethodNode: self.
		testMethodNodes add: node."
		
		theMethod coveringAndNotFixedTestMethods do: createAndAddCoveringNode ].
	
	^ testMethodNodes.! !

OBClassAwareNode subclass: #OBCoveringTestCaseBaseNode
	instanceVariableNames: 'coveredMethodNode definition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Browser'!

!OBCoveringTestCaseBaseNode methodsFor: 'accessing' stamp: 'test 9/22/2009 16:38'!
coveredMethod
	^ coveredMethodNode compiledMethod! !

!OBCoveringTestCaseBaseNode methodsFor: 'accessing' stamp: 'test 9/22/2009 16:38'!
coveredMethodNode
	^ coveredMethodNode ! !

!OBCoveringTestCaseBaseNode methodsFor: 'accessing' stamp: 'test 9/22/2009 16:37'!
coveredMethodNode: anObject
	coveredMethodNode := anObject.
	definition := coveredMethodNode definition.! !

!OBCoveringTestCaseBaseNode methodsFor: 'accessing' stamp: 'test 9/22/2009 16:38'!
definition
	^ definition! !

OBCoveringTestCaseBaseNode subclass: #OBCoveringTestCaseNode
	instanceVariableNames: 'testMethod statistics'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Browser'!

!OBCoveringTestCaseNode class methodsFor: 'as yet unclassified' stamp: 'bs 5/4/2009 21:50'!
on: testMethod statistic: statistics coveredMethodNode: aCoveredMethodNode
	^ self new 
		testMethod: testMethod;
		statistics: statistics;
		coveredMethodNode: aCoveredMethodNode.! !

!OBCoveringTestCaseNode methodsFor: 'as yet unclassified' stamp: 'test 9/22/2009 18:15'!
name
	^ self testMethod methodClass name, ' >> #',self testMethod selector! !

!OBCoveringTestCaseNode methodsFor: 'accessing' stamp: 'bs 5/4/2009 21:21'!
statistics
	^ statistics! !

!OBCoveringTestCaseNode methodsFor: 'accessing' stamp: 'bs 5/4/2009 21:21'!
statistics: anObject
	statistics := anObject! !

!OBCoveringTestCaseNode methodsFor: 'accessing' stamp: 'bs 5/4/2009 20:53'!
testMethod
	^ testMethod! !

!OBCoveringTestCaseNode methodsFor: 'accessing' stamp: 'bs 5/4/2009 20:53'!
testMethod: anObject
	testMethod := anObject! !

OBCoveringTestCaseBaseNode subclass: #OBCoveringTestCaseSeparatorNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Browser'!

!OBCoveringTestCaseSeparatorNode class methodsFor: 'as yet unclassified' stamp: 'test 9/22/2009 16:36'!
coveredMethodNode: aCoveredMethodNode
	^ self new 
		coveredMethodNode: aCoveredMethodNode.! !

!OBCoveringTestCaseSeparatorNode methodsFor: 'as yet unclassified' stamp: 'test 9/22/2009 21:21'!
name
	^ ('---------', String crlf, '---') asText! !

OBNode subclass: #CSCallNode
	instanceVariableNames: 'call identifier'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-TraceBrowser'!

!CSCallNode methodsFor: 'accessing' stamp: 'mp 2/8/2009 17:20'!
call
	"Answer the value of call"

	^ call! !

!CSCallNode methodsFor: 'accessing' stamp: 'mp 2/8/2009 17:20'!
call: anObject
	"Set the value of call"

	call := anObject! !

!CSCallNode methodsFor: 'accessing' stamp: 'mp 2/8/2009 18:09'!
identifier
	"Answer the value of identifier"

	^ identifier! !

!CSCallNode methodsFor: 'accessing' stamp: 'mp 2/8/2009 18:09'!
identifier: anObject
	"Set the value of identifier"

	identifier := anObject! !

!CSCallNode methodsFor: 'public' stamp: 'mp 2/8/2009 18:15'!
name

	^ self call methodClass asString, '>>#', self call methodSelector asString! !

!CSCallNode methodsFor: 'public' stamp: 'mp 2/8/2009 18:28'!
nextCalls

	| nodes |
	nodes := OrderedCollection new.
	self call
		iterateNextMethodTrace: self identifier
		withNextCallBlock: [:callEntry | nodes add: (CSCallNode new identifier: self identifier; call: callEntry)]
		andReturnBlock: [:returnEntry | nodes add: (CSReturnNode new return: returnEntry)].
	^ nodes! !

!CSCallNode methodsFor: 'public' stamp: 'mp 2/8/2009 18:44'!
text

	^ (self call methodClass methodDict at: self call methodSelector) getSource! !

CSCallNode subclass: #CSReturnNode
	instanceVariableNames: 'return'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-TraceBrowser'!

!CSReturnNode methodsFor: 'as yet unclassified' stamp: 'mp 2/8/2009 18:30'!
name

	^ self return returnValue asString! !

!CSReturnNode methodsFor: 'as yet unclassified' stamp: 'mp 2/8/2009 18:29'!
nextCalls
	^ Array new! !

!CSReturnNode methodsFor: 'accessing' stamp: 'mp 2/8/2009 18:29'!
return
	"Answer the value of return"

	^ return! !

!CSReturnNode methodsFor: 'accessing' stamp: 'mp 2/8/2009 18:29'!
return: anObject
	"Set the value of return"

	return := anObject! !

!CSReturnNode methodsFor: 'as yet unclassified' stamp: 'mp 2/15/2009 12:41'!
text

	self return explore.
	^ 'Return value'.! !

OBNode subclass: #CSTraceStartNode
	instanceVariableNames: 'identifier'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-TraceBrowser'!

!CSTraceStartNode methodsFor: 'accessing' stamp: 'mp 2/8/2009 18:05'!
identifier
	"Answer the value of identifier"

	^ identifier! !

!CSTraceStartNode methodsFor: 'accessing' stamp: 'mp 2/8/2009 18:05'!
identifier: anObject
	"Set the value of identifier"

	identifier := anObject! !

!CSTraceStartNode methodsFor: 'as yet unclassified' stamp: 'mp 2/8/2009 18:06'!
name

	^ self identifier asString! !

!CSTraceStartNode methodsFor: 'accessing' stamp: 'mp 2/8/2009 18:33'!
nextCalls
	
	| nodes |
	self identifier ifNil: [^ Array new].
	nodes := (CSTraceRegistry current traces at: self identifier) startEntries 
		collect: [:each | CSCallNode new 
						identifier: self identifier;
						call: each].
	nodes add: (CSReturnNode new identifier: self identifier; return: (CSTraceRegistry current traces at: self identifier) returnValue).
	^ nodes! !

!CSTraceStartNode methodsFor: 'as yet unclassified' stamp: 'mp 2/8/2009 17:31'!
text

	^ 'abc'! !

!CSTraceStartNode methodsFor: 'as yet unclassified' stamp: 'mp 2/8/2009 18:11'!
traces

	self identifier ifNil: [
		^ CSTraceRegistry current traces keys collect: [:each | CSTraceStartNode new identifier: each]].
	^ Array new.! !

!MenuIcons class methodsFor: '*codesight' stamp: 'mt 5/3/2009 20:40'!
csAcceptIcon

	^ Icons
			at: #'csAccept'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self csAcceptIconContents readStream) ].! !

!MenuIcons class methodsFor: '*codesight' stamp: 'mt 5/3/2009 20:39'!
csAcceptIconContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAKfSURBVDjLpZPrS1NhHMf9O3bO
dmwDCWREIYKEUHsVJBI7mg3FvCxL09290jZj2EyLMnJexkgpLbPUanNOberU5taUMnHZUULM
velCtWF0sW/n7MVMEiN64AsPD8/n83uucQDi/id/DBT4Dolypw/qsz0pTMbj/WHpiDgsdSUy
UmeiPt2+V7SrIM+bSss8ySGdR4abQQv6lrui6VxsRonrGCS9VEjSQ9E7CtiqdOZ4UuTqnBHO
1X7YXl6Daa4yGq7vWO1D40wVDtj4kWQbn94myPGkCDPdSesczE2sCZShwl8CzcwZ6NiUs6n2
nYX99T1cnKqA2EKui6+TwphA5k4yqMayopU5mANV3lNQTBdCMVUA9VQh3GuDMHiVcLCS3J4j
SLhCGmKCjBEx0xlshjXYhApfMZRP5CyYD+UkG08+xt+4wLVQZA1tzxthm2tEfD3JxARH7Qkb
D1ZuozaggdZbxK5kAIsf5qGaKMTY2lAU/rH5HW3PLsEwUYy+YCcERmIjJpDcpzb6l7th9KtQ
69fi09ePUej9l7cx2DJbD7UrG3r3afQHOyCo+V3QQzE35pvQvnAZukk5zL5qRL59jsKbPzdh
eXoBZc4saFhBS6AO7V4zqCpiawuptwQG+UAa7Ct3UT0hh9p9EnXT5Vh6t4C22QaUDh6HwnEC
OmcO7K+6kW49DKqS2DrEZCtfuI+9GrNHg4fMHVSO5kE7nAPVkAxKBxcOzsajpS4Yh4ohUPPW
KTUh3PaQEptIOr6BiJjcZXCwktaAGfrRIpwblqOV3YKdhfXOIvBLeREWpnd8ynsaSJoyESFp
hwTtfjN6X1jRO2+FxWtCWksqBApeiFIR9K6fiTpPiigDoadqCEag5YUFKl6Yrciw0VOlhOiv
v/Ff8wtn0KzlebrUYwAAAABJRU5ErkJggg=='! !

!MenuIcons class methodsFor: '*codesight' stamp: 'rkrk 9/22/2009 07:08'!
csBlankBarIcon

	^ Form extent: 57@24.! !

!MenuIcons class methodsFor: '*codesight' stamp: 'rkrk 9/22/2009 06:55'!
csGreenBarIcon

	^ Icons
			at: #'csGreenBar'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self csGreenBarIconContents readStream) ].! !

!MenuIcons class methodsFor: '*codesight' stamp: 'rkrk 9/22/2009 06:54'!
csGreenBarIconContents

	^  'iVBORw0KGgoAAAANSUhEUgAAADkAAAAYCAYAAABA6FUWAAAACXBIWXMAAAsTAAALEwEAmpwY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'! !

!MenuIcons class methodsFor: '*codesight' stamp: 'rkrk 9/30/2009 05:17'!
csHourGlassIcon

	^ Icons
			at: #'csHourGlassIcon'
			ifAbsentPut: [((CursorWithMask
	extent: 16@16
	depth: 1
	fromArray: #( 0 2147352576 1073872896 537133056 268959744 242221056 132120576 62914560 62914560 77594624 143654912 281542656 568590336 1207566336 2147352576 0)
	offset: -1@-1) setMaskForm: (Form
	extent: 16@16
	depth: 1
	fromArray: #( 4294901760 4294901760 4294901760 4162781184 2147352576 1073479680 536346624 267386880 267386880 536346624 1073479680 2147352576 4294901760 4294901760 4294901760 4294901760)
	offset: 0@0)) as8BitColorForm].! !

!MenuIcons class methodsFor: '*codesight' stamp: 'rkrk 9/22/2009 06:56'!
csRedBarIcon

	^ Icons
			at: #'csRedBar'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self csRedBarIconContents readStream) ].! !

!MenuIcons class methodsFor: '*codesight' stamp: 'rkrk 9/22/2009 06:56'!
csRedBarIconContents

	^   'iVBORw0KGgoAAAANSUhEUgAAADkAAAAYCAYAAABA6FUWAAAACXBIWXMAAAsTAAALEwEAmpwY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'! !

MwMethodWrapper variableByteSubclass: #CSCoverageTracingWrapper
	instanceVariableNames: ''
	classVariableNames: 'TracedClasses HandlesSystemEvents IsChangingInstrumentation RegisteredPackages RegisteredMethods PostProcessingHandlers RunningTestMethod MethodsNotToBeWrapped TraceDepth IsActive IsActiveCounter RegisteredClasses'
	poolDictionaries: ''
	category: 'CodeSight-TestTracer'!

!CSCoverageTracingWrapper class methodsFor: 'tracing' stamp: 'bs 10/6/2009 14:00'!
activateTracing
	IsActiveCounter ifNil: [IsActiveCounter := 0].
	IsActiveCounter := IsActiveCounter + 1.
	IsActive := IsActiveCounter > 0.! !

!CSCoverageTracingWrapper class methodsFor: 'registration' stamp: 'bs 10/28/2009 08:30'!
canInstrument: selector inClass: aClass
	^ self canWrap: selector inClass: aClass.! !

!CSCoverageTracingWrapper class methodsFor: 'wrapping' stamp: 'bs 10/6/2009 09:50'!
canWrap: aSelector inClass: aClass
	^ ((self canWrapClass: aClass) and: [self canWrapMethod: aSelector inClass: aClass])
			ifFalse: [false]
			ifTrue: [super canWrap: aSelector inClass: aClass]! !

!CSCoverageTracingWrapper class methodsFor: 'wrapping' stamp: 'bs 10/6/2009 22:37'!
canWrapClass: aClass
	|classesNotToBeWrapped|
	classesNotToBeWrapped := {CSTestStatistic}.
	^ (classesNotToBeWrapped includes: aClass) not! !

!CSCoverageTracingWrapper class methodsFor: 'wrapping' stamp: 'bs 10/6/2009 09:53'!
canWrapMethod: aSelector inClass: aClass
	^ (self methodsNotToBeWrapped includesKey: aClass)
			ifFalse: [true]
			ifTrue: [
				((self methodsNotToBeWrapped at: aClass) includes: aSelector) not]! !

!CSCoverageTracingWrapper class methodsFor: 'registration' stamp: 'bs 10/28/2009 08:23'!
changingInstrumentationDo: aBlock
	self isChangingInstrumentation: true.
	aBlock value.
	self isChangingInstrumentation: false.
	! !

!CSCoverageTracingWrapper class methodsFor: 'system event handling' stamp: 'test 9/21/2009 14:57'!
classAdded: anAddedEvent
	|aClass aClassPackage|
	aClass := anAddedEvent item.
	aClassPackage := PackageOrganizer default
		packageOfClass: aClass
		ifNone: [PackageInfo named: (Smalltalk organization categoryOfElement: aClass name)].
	(self registeredPackages includes: aClassPackage)
		ifTrue: [self registerClass: aClass].
	self systemEventPostProcessingHandlers do: [:handler |
		handler classAdded: anAddedEvent ]! !

!CSCoverageTracingWrapper class methodsFor: 'system event handling' stamp: 'test 9/21/2009 14:57'!
classModified: aModifiedEvent
	|aClass|
	aClass := aModifiedEvent item.
	(self registeredClasses includes: aClass) 
		ifTrue: [
			self unregisterClass: aClass.
			self registerClass: aClass].
		
	self systemEventPostProcessingHandlers do: [:handler |
		handler classModified: aModifiedEvent ]! !

!CSCoverageTracingWrapper class methodsFor: 'system event handling' stamp: 'bs 9/11/2009 16:28'!
classRemoved: aRemovedEvent
	self unregisterClass: aRemovedEvent item.
	self systemEventPostProcessingHandlers do: [:handler |
		handler classRemoved: aRemovedEvent ]! !

!CSCoverageTracingWrapper class methodsFor: 'tracing' stamp: 'bs 10/6/2009 14:01'!
deactivateTracing
	IsActiveCounter ifNil: [IsActiveCounter := 0].
	IsActiveCounter := IsActiveCounter - 1.
	IsActive := IsActiveCounter > 0.! !

!CSCoverageTracingWrapper class methodsFor: 'tracing' stamp: 'bs 9/3/2009 18:34'!
decrementTraceDepth
	self traceDepth: self traceDepth - 1! !

!CSCoverageTracingWrapper class methodsFor: 'system event handling' stamp: 'bs 9/9/2009 15:38'!
handlesSystemEvents
	^ HandlesSystemEvents ifNil: [HandlesSystemEvents := false].! !

!CSCoverageTracingWrapper class methodsFor: 'system event handling' stamp: 'bs 9/9/2009 16:10'!
handlesSystemEvents: aBoolean
	^ HandlesSystemEvents := aBoolean! !

!CSCoverageTracingWrapper class methodsFor: 'tracing' stamp: 'bs 9/3/2009 18:35'!
incrementTraceDepth
	self traceDepth: self traceDepth + 1! !

!CSCoverageTracingWrapper class methodsFor: 'as yet unclassified' stamp: 'bs 9/9/2009 15:59'!
initialize
	"doIt: [self initialize]"

	super initialize.
	self startHandlingSystemEvents.! !

!CSCoverageTracingWrapper class methodsFor: 'registration' stamp: 'bs 10/28/2009 08:33'!
instrument: selector inClass: aClass
	| wrapper |
	self changingInstrumentationDo: [
		wrapper := self on: selector inClass: aClass.
		wrapper install ].
	
	! !

!CSCoverageTracingWrapper class methodsFor: 'registration' stamp: 'bs 10/28/2009 08:22'!
isChangingInstrumentation
	^ IsChangingInstrumentation
	! !

!CSCoverageTracingWrapper class methodsFor: 'registration' stamp: 'bs 10/28/2009 08:22'!
isChangingInstrumentation: aBoolean
	^ IsChangingInstrumentation := aBoolean
	! !

!CSCoverageTracingWrapper class methodsFor: 'registration' stamp: 'bs 9/9/2009 15:43'!
isRegisteredMethod: selector inClass: aClass
	^ (self registeredMethodsAt: aClass) includes: selector
	! !

!CSCoverageTracingWrapper class methodsFor: 'tracing' stamp: 'bs 9/23/2009 15:45'!
isTracingActivated
	^ IsActive ifNil: [IsActive := false]! !

!CSCoverageTracingWrapper class methodsFor: 'system event handling' stamp: 'test 9/21/2009 22:10'!
methodAdded: anAddedEvent
	| selector class |
	selector := anAddedEvent itemSelector.
	class := anAddedEvent itemClass.
	(self registeredClasses includes: class) ifTrue: [
		self registerMethod: selector inClass: class].
	
	self systemEventPostProcessingHandlers do: [:handler | 
			handler methodAdded: anAddedEvent ].! !

!CSCoverageTracingWrapper class methodsFor: 'system event handling' stamp: 'bs 10/28/2009 09:02'!
methodModified: aModifiedEvent
	| selector class |
	self isChangingInstrumentation ifTrue: [^ self].
	
	selector := aModifiedEvent itemSelector.
	class := aModifiedEvent itemClass.
	
	(self isRegisteredMethod: selector inClass: class) ifTrue: [
		self removeOnlyRegistrationForMethod: selector inClass: class.
		self registerMethod: selector inClass: class].
	
	self systemEventPostProcessingHandlers do: [:handler | 
		handler methodModified: aModifiedEvent ]! !

!CSCoverageTracingWrapper class methodsFor: 'system event handling' stamp: 'test 9/21/2009 22:11'!
methodRemoved: aRemovedEvent
		| selector class |
	selector := aRemovedEvent itemSelector.
	class := aRemovedEvent itemClass.
	
	(self isRegisteredMethod: selector inClass: class) ifTrue: [
		self unregisterMethod: selector inClass: class].
	
	self systemEventPostProcessingHandlers do: [:handler | 
		handler methodRemoved: aRemovedEvent ]! !

!CSCoverageTracingWrapper class methodsFor: 'wrapping' stamp: 'bs 10/6/2009 22:20'!
methodsNotToBeWrapped
	| result |
	result := Dictionary new.
	result 
		at: (CSCoverageTracingWrapper class) 
		put: (#(#isTracingActivated #decrementTraceDepth #incrementTraceDepth #runningTestMethod #traceDepth #traceDepth: )).
		
"	result 
		at: (CSTestRunner) 
		put: (#(#basicSetUpSuite: #runTest: #runSuite: #reset #testCasesToRun #resetTestCasesToRun #runsTestsInBackground #methodsCoveredBeforeRun #resetMethodsCoveredBeforeRun #runTestsInBackground #runOpenTestCasesInSuite))."
		
	^ result! !

!CSCoverageTracingWrapper class methodsFor: 'registration' stamp: 'bs 10/6/2009 08:45'!
registerClass: aClass
	|metaClass|
	metaClass := aClass class.
	(self registeredClasses includes: aClass) ifFalse: [
		{aClass. metaClass} do: [:c |
			self registeredClasses add: c.
			c selectors do: [:selector | self registerMethod: selector inClass: c ]]].! !

!CSCoverageTracingWrapper class methodsFor: 'registration' stamp: 'bs 10/28/2009 08:34'!
registerMethod: selector inClass: aClass
	| registeredMethods |
	((aClass inheritsFrom: TestCase) and: [selector isTestSelector])
		ifFalse: [
			registeredMethods := self registeredMethodsAt: aClass.
			(registeredMethods includes: selector) ifFalse: [
				(self canInstrument: selector inClass: aClass) ifTrue: [
					self instrument: selector inClass: aClass.
					registeredMethods add: selector.]]]! !

!CSCoverageTracingWrapper class methodsFor: 'public' stamp: 'bs 9/9/2009 15:10'!
registerPackage: aPackage
	(self registeredPackages includes: aPackage) ifFalse: [
		self registeredPackages add: aPackage.
		aPackage classes do: [:aClass | self registerClass: aClass]]! !

!CSCoverageTracingWrapper class methodsFor: 'registration' stamp: 'bs 9/11/2009 23:35'!
registeredClasses
	"RegisteredClasses := nil"
	^ RegisteredClasses ifNil: [RegisteredClasses := WeakSet new]! !

!CSCoverageTracingWrapper class methodsFor: 'registration' stamp: 'bs 10/6/2009 20:14'!
registeredMethods
	^ RegisteredMethods ifNil: [RegisteredMethods := WeakKeyDictionary new]! !

!CSCoverageTracingWrapper class methodsFor: 'registration' stamp: 'bs 9/9/2009 14:42'!
registeredMethodsAt: aClass
	^ self registeredMethods at: aClass ifAbsentPut: [Set new]
	
	"(self registeredPackages includes: aPackage) ifFalse: [
		self registeredPackages add: aPackage.
		aPackage classes reject: [:aClass | aClass inheritsFrom: TestCase]
							  thenDo: [:class | class selectors do: [:selector | 
				(self on: selector inClass: class) ifNotNilDo: [:wrapper | wrapper install]]]]"! !

!CSCoverageTracingWrapper class methodsFor: 'registration' stamp: 'bs 9/10/2009 19:10'!
registeredPackages
	"RegisteredPackages := nil"
	^ RegisteredPackages ifNil: [RegisteredPackages := WeakSet new]! !

!CSCoverageTracingWrapper class methodsFor: 'registration' stamp: 'bs 9/9/2009 15:55'!
removeOnlyRegistrationForMethod: selector inClass: aClass
	| registeredMethods |
	registeredMethods := self registeredMethodsAt: aClass.
	(registeredMethods includes: selector) ifTrue: [
		registeredMethods remove: selector].! !

!CSCoverageTracingWrapper class methodsFor: 'tracing' stamp: 'bs 9/3/2009 18:36'!
resetTraceDepth
	TraceDepth := 0! !

!CSCoverageTracingWrapper class methodsFor: 'tracing' stamp: 'bs 9/3/2009 18:39'!
runningTestMethod
	^ RunningTestMethod
	! !

!CSCoverageTracingWrapper class methodsFor: 'system event handling' stamp: 'bs 9/10/2009 21:51'!
startHandlingSystemEvents
	"CSCoverageTracingWrapper startHandlingSystemEvents"
	
	|notifier events eventItem handlerMethodSelector|
	events := {#method -> {#Added. #Modified. #Removed}. #class -> {#Added. #Modified. #Removed}}.
	self handlesSystemEvents ifFalse: [
		self handlesSystemEvents: true.
		notifier := SystemChangeNotifier uniqueInstance.
		events do: [:assoc | 
			eventItem := assoc key.
			assoc value do: [:changeKind | 
				handlerMethodSelector := (eventItem, changeKind, ':') asSymbol.
				notifier notify: self ofSystemChangesOfItem: eventItem 
					change: changeKind using: handlerMethodSelector]]]! !

!CSCoverageTracingWrapper class methodsFor: 'system event handling' stamp: 'bs 9/9/2009 16:12'!
stopHandlingSystemEvents
	"CSCoverageTracingWrapper stopHandlingSystemEvents" 
	
	self handlesSystemEvents ifTrue: [
		self handlesSystemEvents: false.
		SystemChangeNotifier uniqueInstance noMoreNotificationsFor: self]! !

!CSCoverageTracingWrapper class methodsFor: 'system event handling' stamp: 'bs 9/9/2009 15:57'!
systemEventPostProcessingHandlers
	^ PostProcessingHandlers ifNil: [PostProcessingHandlers := Set new]! !

!CSCoverageTracingWrapper class methodsFor: 'tracing' stamp: 'bs 9/3/2009 18:38'!
testMethodGoingToRun: aCompiledMethod
	self resetTraceDepth.
	RunningTestMethod := aCompiledMethod
	! !

!CSCoverageTracingWrapper class methodsFor: 'tracing' stamp: 'bs 9/3/2009 18:35'!
traceDepth
	^ TraceDepth ifNil: [TraceDepth := 0]! !

!CSCoverageTracingWrapper class methodsFor: 'tracing' stamp: 'bs 9/3/2009 18:35'!
traceDepth: aNumber
	TraceDepth := aNumber! !

!CSCoverageTracingWrapper class methodsFor: 'registration' stamp: 'bs 10/28/2009 09:00'!
uninstrument: selector inClass: aClass
	self changingInstrumentationDo: [
		aClass methodDict at: selector ifPresent: [ :aMethod | 
			aMethod isMwMethodWrapper ifTrue: [ aMethod uninstall ] ] ]
	
	! !

!CSCoverageTracingWrapper class methodsFor: 'public' stamp: 'bs 10/6/2009 21:25'!
unregisterAllAndReset
	self registeredPackages do: [:ea | self unregisterPackage: ea].
	self registeredClasses do: [:ea | self unregisterClass: ea].
	self registeredMethods keysAndValuesDo: [ :aClass :selectors | 
		selectors do: [:s | self unregisterMethod: s inClass: aClass] ].
	self registeredMethods keysAndValuesRemove: [:k :v| true].! !

!CSCoverageTracingWrapper class methodsFor: 'registration' stamp: 'bs 9/30/2009 17:37'!
unregisterClass: aClass
	| metaClass |
	metaClass := aClass class.
	(self registeredClasses includes: aClass)
		ifTrue: [
			self registeredClasses remove: aClass.
			self registeredClasses remove: metaClass ifAbsent:[]].
	
	{aClass. metaClass} do: [:c |
		c selectors do: [:selector | self unregisterMethod: selector inClass: c ]].! !

!CSCoverageTracingWrapper class methodsFor: 'registration' stamp: 'bs 10/28/2009 08:58'!
unregisterMethod: selector inClass: aClass
	| registeredMethods |
	registeredMethods := self registeredMethodsAt: aClass.
	(registeredMethods includes: selector) 
		ifTrue: [
			self uninstrument: selector inClass: aClass.
			registeredMethods remove: selector].! !

!CSCoverageTracingWrapper class methodsFor: 'public' stamp: 'bs 10/6/2009 12:01'!
unregisterPackage: aPackage
	(self registeredPackages includes: aPackage) ifTrue: [
		aPackage classes do: [:aClass | self unregisterClass: aClass].
		self registeredPackages remove: aPackage]! !

!CSCoverageTracingWrapper methodsFor: 'evaluating' stamp: 'bs 9/9/2009 13:46'!
afterMethod
	self ifActive: [
		self class decrementTraceDepth]! !

!CSCoverageTracingWrapper methodsFor: 'evaluating' stamp: 'rkrk 10/6/2009 14:32'!
beforeMethod

	self flag: #rkrk. "for benchmarking"
	self ifActive: [
		self class incrementTraceDepth.
		self class runningTestMethod 
			called: self clientMethod
			inDepth: self class traceDepth]! !

!CSCoverageTracingWrapper methodsFor: 'evaluating' stamp: 'rkrk 10/6/2009 14:30'!
beforeMethodWithReceiver: anObject.
	self ifActive: [
		self class incrementTraceDepth.
		self class runningTestMethod 
			called: self clientMethod
			inDepth: self class traceDepth
			receiver: anObject]! !

!CSCoverageTracingWrapper methodsFor: 'client method forwarding' stamp: 'rkrk 10/6/2009 14:31'!
called: aCompiledMethod inDepth: aNumber
	"for benchmarking"
	self flag: #rkrk.
	^ self clientMethod called: aCompiledMethod inDepth: aNumber.! !

!CSCoverageTracingWrapper methodsFor: 'client method forwarding' stamp: 'test 9/21/2009 15:58'!
called: aCompiledMethod inDepth: aNumber receiver: anObject
	^ self clientMethod called: aCompiledMethod inDepth: aNumber receiver: anObject! !

!CSCoverageTracingWrapper methodsFor: 'evaluating' stamp: 'bs 9/9/2009 15:22'!
compiledMethod
	^ self clientMethod! !

!CSCoverageTracingWrapper methodsFor: 'client method forwarding' stamp: 'bs 9/9/2009 16:49'!
coveredMethods
	^ self clientMethod coveredMethods! !

!CSCoverageTracingWrapper methodsFor: 'client method forwarding' stamp: 'bs 9/9/2009 16:48'!
coveredMethodsStatistics
	^ self clientMethod coveredMethodsStatistics! !

!CSCoverageTracingWrapper methodsFor: 'client method forwarding' stamp: 'test 9/22/2009 16:50'!
coveringAndNotFixedTestMethods
	^ self clientMethod coveringAndNotFixedTestMethods! !

!CSCoverageTracingWrapper methodsFor: 'client method forwarding' stamp: 'bs 9/9/2009 16:28'!
coveringTestMethods
	^ self clientMethod coveringTestMethods! !

!CSCoverageTracingWrapper methodsFor: 'client method forwarding' stamp: 'test 9/21/2009 16:20'!
coveringTestMethodsWhenReceiverWasOfKind: aClass
	^ self clientMethod coveringTestMethodsWhenReceiverWasOfKind: aClass! !

!CSCoverageTracingWrapper methodsFor: 'client method forwarding' stamp: 'test 9/18/2009 20:28'!
doForEachCoveredMethod
	^ self clientMethod doForEachCoveredMethod! !

!CSCoverageTracingWrapper methodsFor: 'client method forwarding' stamp: 'test 9/18/2009 20:29'!
doForEachCoveredMethod: aBlock
	^ self clientMethod doForEachCoveredMethod: aBlock! !

!CSCoverageTracingWrapper methodsFor: 'client method forwarding' stamp: 'bs 9/16/2009 21:18'!
fixedTestMethods
	^ self clientMethod fixedTestMethods! !

!CSCoverageTracingWrapper methodsFor: 'client method forwarding' stamp: 'bs 10/6/2009 12:09'!
fixes: aTestMethod
	^ self clientMethod fixes: aTestMethod! !

!CSCoverageTracingWrapper methodsFor: 'client method forwarding' stamp: 'bs 10/6/2009 12:09'!
fixesAll: testMethods
	^ self clientMethod fixesAll: testMethods! !

!CSCoverageTracingWrapper methodsFor: 'client method forwarding' stamp: 'bs 9/4/2009 19:46'!
hasCoveringTestMethods
	^ self clientMethod hasCoveringTestMethods! !

!CSCoverageTracingWrapper methodsFor: 'client method forwarding' stamp: 'test 9/18/2009 08:35'!
hasFixedTestMethods
	^ self clientMethod hasFixedTestMethods! !

!CSCoverageTracingWrapper methodsFor: 'evaluating' stamp: 'bs 9/8/2009 18:36'!
ifActive: aBlock
	self isActive ifTrue: [aBlock value]! !

!CSCoverageTracingWrapper methodsFor: 'evaluating' stamp: 'bs 9/11/2009 21:56'!
isActive
	^ self class isTracingActivated! !

!CSCoverageTracingWrapper methodsFor: 'client method forwarding' stamp: 'bs 9/9/2009 17:09'!
methodClass
	^ self clientMethod methodClass! !

!CSCoverageTracingWrapper methodsFor: 'client method forwarding' stamp: 'test 9/20/2009 14:24'!
newTestCase
	^ self clientMethod newTestCase! !

!CSCoverageTracingWrapper methodsFor: 'client method forwarding' stamp: 'test 9/20/2009 14:44'!
overriddenAndOverridingMethods
	^ self clientMethod overriddenAndOverridingMethods! !

!CSCoverageTracingWrapper methodsFor: 'client method forwarding' stamp: 'test 9/20/2009 21:28'!
overriddenAndOverridingMethodsIn: aClass
	^ self clientMethod overriddenAndOverridingMethodsIn: aClass! !

!CSCoverageTracingWrapper methodsFor: 'client method forwarding' stamp: 'test 9/20/2009 14:44'!
overriddenMethod
	^ self clientMethod overriddenMethod! !

!CSCoverageTracingWrapper methodsFor: 'client method forwarding' stamp: 'test 9/20/2009 21:28'!
overriddenMethodIn: aClass
	^ self clientMethod overriddenMethodIn: aClass! !

!CSCoverageTracingWrapper methodsFor: 'client method forwarding' stamp: 'test 9/20/2009 14:44'!
overridingMethods
	^ self clientMethod overridingMethods! !

!CSCoverageTracingWrapper methodsFor: 'client method forwarding' stamp: 'test 9/20/2009 21:29'!
overridingMethodsIn: aClass
	^ self clientMethod overridingMethodsIn: aClass! !

!CSCoverageTracingWrapper methodsFor: 'client method forwarding' stamp: 'bs 9/11/2009 22:41'!
removeCoveredMethod: aCompiledAppMethod
	^ self clientMethod removeCoveredMethod: aCompiledAppMethod! !

!CSCoverageTracingWrapper methodsFor: 'client method forwarding' stamp: 'bs 9/23/2009 18:43'!
removeCoveringTestMethod: aTestCaseMethod
	^ self clientMethod removeCoveringTestMethod: aTestCaseMethod! !

!CSCoverageTracingWrapper methodsFor: 'client method forwarding' stamp: 'test 9/21/2009 10:54'!
removeFixedTestMethodIfNotCoveringAnymore: aTestCaseMethod
	^ self clientMethod removeFixedTestMethodIfNotCoveringAnymore: aTestCaseMethod.! !

!CSCoverageTracingWrapper methodsFor: 'client method forwarding' stamp: 'bs 9/23/2009 16:06'!
resetAllCoverageData
	^ self clientMethod resetAllCoverageData! !

!CSCoverageTracingWrapper methodsFor: 'client method forwarding' stamp: 'bs 9/9/2009 16:45'!
resetCoveredMethodsStatistics
	^ self clientMethod resetCoveredMethodsStatistics! !

!CSCoverageTracingWrapper methodsFor: 'client method forwarding' stamp: 'bs 9/11/2009 22:42'!
resetCoveringTestMethods
	^ self clientMethod resetCoveringTestMethods! !

!CSCoverageTracingWrapper methodsFor: 'client method forwarding' stamp: 'bs 9/23/2009 21:17'!
resetDoForEachCoveredMethod
	^ self clientMethod resetDoForEachCoveredMethod! !

!CSCoverageTracingWrapper methodsFor: 'client method forwarding' stamp: 'test 9/21/2009 09:28'!
resetFixedTestMethods
	^ self clientMethod resetFixedTestMethods! !

!CSCoverageTracingWrapper methodsFor: 'client method forwarding' stamp: 'bs 9/9/2009 17:13'!
selector
	^ self clientMethod selector! !

!CSCoverageTracingWrapper methodsFor: 'client method forwarding' stamp: 'bs 9/9/2009 16:45'!
statisticsForCoveredMethod: aCompiledMethod
	^ self clientMethod statisticsForCoveredMethod: aCompiledMethod! !

!CSCoverageTracingWrapper methodsFor: 'evaluating' stamp: 'bs 10/8/2009 15:51'!
valueWithReceiver: anObject arguments: anArrayOfObjects
	self beforeMethodWithReceiver: anObject.
	^ [
		self clientMethod valueWithReceiver: anObject arguments: anArrayOfObjects.
	] ensure: [self afterMethod].! !

!MwMethodWrapper methodsFor: '*CodeSight' stamp: 'bs 9/23/2009 16:10'!
compiledMethod
	^ self clientMethod! !

!OBMethodCategoryNode methodsFor: '*codesight' stamp: 'bs 9/14/2009 20:55'!
backgroundColor
	| methodSelectors methodsToBeChecked |
	
	(CSCoverageTracingWrapper registeredClasses includes: theClass)
		ifTrue: [
			methodSelectors := (name = ClassOrganizer allCategory)
				ifTrue: [theClass organization allMethodSelectors]
				ifFalse: [theClass organization listAtCategoryNamed: name].
			
			methodsToBeChecked := methodSelectors select: [:aSelector | aSelector isTestSelector not ] 
														 	  thenCollect: [:aSelector | theClass compiledMethodAt: aSelector].
				
			(methodsToBeChecked allSatisfy: [:aMethod | aMethod hasCoveringTestMethods])
				ifFalse: [^ Color lightOrange]].
	
	^ super backgroundColor! !

OBCommand subclass: #CSCmdShowTestResult
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Browser'!

!CSCmdShowTestResult methodsFor: 'accessing' stamp: 'rkrk 9/30/2009 01:56'!
browser

	^ requestor browser! !

!CSCmdShowTestResult methodsFor: 'icon assembly' stamp: 'rkrk 9/30/2009 05:28'!
buttonLabelWithSpaces

	| fillColor frame canvas |
	fillColor := self testsAreGreen
		ifTrue: [Color green]
		ifFalse: [Color red].
	frame := 0@0 corner: 60@25.
	canvas := self canvasFits: frame colored: fillColor.
	self browser isRunning ifTrue: [
		self
			drawHourglassOn: canvas
			colored: fillColor
			at: 10@5].
	self defectCount isZero ifFalse: [
		self
			drawString: self defectCount asString
			on: canvas
			fitting: (30@5 corner: 55@20)].
	^ canvas form asMorph.! !

!CSCmdShowTestResult methodsFor: 'icon assembly' stamp: 'rkrk 9/30/2009 05:27'!
canvasFits: frame colored: fillColor

	| canvas rounding roundingLeft roundingRight |
	canvas :=(FormCanvas extent: frame extent depth: 16) asAlphaBlendingCanvas: 1.
	
	rounding := 20.
	roundingLeft := frame topLeft corner: (frame right-rounding)@frame bottom.
	canvas fillOval: roundingLeft color: fillColor.
	roundingRight := (frame left+rounding)@frame top corner: frame bottomRight.
	canvas fillOval: roundingRight color: fillColor.
	canvas
		fillRectangle: (roundingRight topLeft corner: roundingLeft bottomRight)
		color: fillColor.

	^ canvas.! !

!CSCmdShowTestResult methodsFor: 'icon assembly' stamp: 'rkrk 9/30/2009 02:33'!
defectCount

	^ self testResult failureCount + self testResult errorCount! !

!CSCmdShowTestResult methodsFor: 'icon assembly' stamp: 'rkrk 9/30/2009 05:28'!
drawHourglassOn: canvas colored: fillColor at: pt

	| hourglass |
	hourglass := MenuIcons csHourGlassIcon deepCopy
		mapColor: Color white
		to: fillColor.
	canvas translucentImage: hourglass at: pt.! !

!CSCmdShowTestResult methodsFor: 'icon assembly' stamp: 'rkrk 9/30/2009 04:37'!
drawString: string on: canvas fitting: rect

	canvas drawString: string in: rect.! !

!CSCmdShowTestResult methodsFor: 'icon assembly' stamp: 'rkrk 10/7/2009 11:15'!
dummyLabelGreen: isGreen running: isRunning defectCount: defects

	| fillColor frame canvas |
	fillColor := isGreen
		ifTrue: [Color green]
		ifFalse: [Color red].
	frame := 0@0 corner: 60@25.
	canvas := self canvasFits: frame colored: fillColor.
	isRunning ifTrue: [
		self
			drawHourglassOn: canvas
			colored: fillColor
			at: 10@5].
	defects isZero ifFalse: [
		self
			drawString: defects asString
			on: canvas
			fitting: (30@5 corner: 55@20)].
	^ canvas form asMorph.! !

!CSCmdShowTestResult methodsFor: 'execution' stamp: 'rkrk 9/30/2009 01:57'!
execute

	| runner runnerMorph |
	runner := self browser testRunner.
	runnerMorph := World submorphs
		detect: [:ea | (ea respondsTo: #model) and: [ea model = runner]]
		ifNone: [runner buildWith: MorphicToolBuilder new].
	runnerMorph openInWorld.! !

!CSCmdShowTestResult methodsFor: 'accessing' stamp: 'rkrk 9/22/2009 02:20'!
group
	^ #codesight! !

!CSCmdShowTestResult methodsFor: 'testing' stamp: 'rkrk 9/22/2009 02:19'!
isActive
	^ true! !

!CSCmdShowTestResult methodsFor: 'icon assembly' stamp: 'rkrk 9/30/2009 02:28'!
isRunning

	^ self browser isRunning! !

!CSCmdShowTestResult methodsFor: 'accessing' stamp: 'rkrk 9/30/2009 02:31'!
testResult

	^ self browser testRunner result! !

!CSCmdShowTestResult methodsFor: 'icon assembly' stamp: 'rkrk 9/30/2009 02:31'!
testsAreGreen

	^ (self testResult hasErrors or: [self testResult hasFailures]) not! !

!CSCmdShowTestResult methodsFor: 'testing' stamp: 'rkrk 9/22/2009 02:19'!
wantsButton

	^ true
! !

OBPackageBrowser subclass: #CSBrowser
	instanceVariableNames: 'isRunning'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeSight-Browser'!

!CSBrowser class methodsFor: 'as yet unclassified' stamp: 'bs 5/2/2009 23:32'!
buildMetagraphOn: root class: classSel comment: commentSel metaclass: metaclassSel 
     | metaGraph |
     metaGraph := CSMetagraphBuilder
		               on: root class: classSel comment: commentSel metaclass: metaclassSel.
	metaGraph classMetaNode doubleClickCommandClass: OBEnhancementCmdBrowseHierarchy.
	metaGraph metaclassMetaNode doubleClickCommandClass: OBEnhancementCmdBrowseHierarchy.
	"metaGraph methodMetaNode doubleClickCommandClass: OBCmdSelectMethodCategory."
	^metaGraph execute ! !

!CSBrowser class methodsFor: 'as yet unclassified' stamp: 'bs 5/2/2009 20:52'!
defaultMetaNode
     | env smartGroup package cats classes builder |
	env := OBMetaNode named: 'Environment'.
	package := OBMetaNode named: 'Package'.
	package
	      displaySelector: #indentedName;
	      ancestrySelector: #isDescendantOfPackage:.
	cats := OBMetaNode named: 'Cats'.
	cats
	      displaySelector: #nameWithoutPrefix;	
	      ancestrySelector: #isDescendantOfClassCat:.	
	(package childAt: #classCategories put: cats) navigateTree.
	
	self buildMetagraphOn: package.
	"self buildMetagraphOn: cats."
     (package edges reject: [:edge | edge selector = #classCategories]) do: [:edge | cats addEdge: edge].
	package filters do: [:filter | cats addFilter: filter].

	classes := OBMetaNode named: 'Classes'.
	classes
		displaySelector: #indentedName;
		ancestrySelector: #isDescendantOfClass:.
	builder := CSMetagraphBuilder
		         on: classes 
	              class: #packagesForClassClass 
	              comment: #packagesForClassComment 
	              metaclass: #packagesForClassMetaclass.
	builder execute.
	builder classMetaNode removeFilter: OBClassInheritanceFilter new; displaySelector: #indentedName.		
	builder metaclassMetaNode removeFilter: OBClassInheritanceFilter new; displaySelector: #indentedName.		
	builder classCommentMetaNode removeFilter: OBClassInheritanceFilter new; displaySelector: #indentedName.							
	classes removeFilter: OBQueryingClassSortFilter new.
	
     smartGroup := OBMetaNode named: 'SmartGroup'.
     smartGroup
		displaySelector: #indentedName.
	(package edges reject: [:edge | edge selector = #classCategories]) do: [:edge | smartGroup addEdge: edge].
	smartGroup addFilter: OBModalFilter new;
		          addFilter: OBClassSortFilter new.
	
     env
		childAt: #packages
			labeled: 'pkgs'
			put: package;
		childAt: #classesHierarchically
			labeled: 'hier.'
			put: classes;				
		childAt: #smartGroups
			labeled: 'smart groups'
			put: smartGroup;
		addFilter: OBModalFilter new.
     ^env! !

!CSBrowser class methodsFor: 'as yet unclassified' stamp: 'bs 4/30/2009 23:12'!
paneCount
	^ 5! !

!CSBrowser class methodsFor: 'as yet unclassified' stamp: 'rkrk 10/6/2009 13:35'!
title
	^ 'Browser'! !

!CSBrowser methodsFor: 'autotdd - test runner dependence' stamp: 'rkrk 9/22/2009 03:23'!
addTestRunnerDependence

	self testRunner addDependent: self.! !

!CSBrowser methodsFor: 'commands' stamp: 'rkrk 9/22/2009 02:15'!
cmdShowTestResult
	^ CSCmdShowTestResult! !

!CSBrowser methodsFor: 'accessing' stamp: 'rkrk 9/30/2009 02:44'!
isRunning

	^ isRunning ifNil: [isRunning := false].! !

!CSBrowser methodsFor: 'opening' stamp: 'rkrk 9/22/2009 03:23'!
open

	super open.
	self addTestRunnerDependence.! !

!CSBrowser methodsFor: 'as yet unclassified' stamp: 'bs 5/4/2009 21:43'!
selectionChanged: announcement
	
	| node testMethod testClass testSelector testSuite |	
	node := announcement node.
	(node isNil not and: [ node isKindOf: OBCoveringTestCaseNode]) ifTrue: [
		testMethod := node testMethod.
		testClass := testMethod methodClass.
		testSelector := testMethod selector.
		testSuite := testClass suiteWithSelectorsMatching: testSelector.
		[
		BreakpointManager installSelfRemovingBreakpointInClass: (node coveredMethod methodClass) selector: (node coveredMethod selector).
		[ testSuite run ] ensure: [ 
			BreakpointManager unInstallInClass: (node coveredMethod methodClass) selector: (node coveredMethod selector). ].
		] forkAt: Processor activePriority.].! !

!CSBrowser methodsFor: 'as yet unclassified' stamp: 'bs 5/4/2009 20:48'!
subscribe
	super subscribe.
	self announcer
		observe: OBSelectionChanged send: #selectionChanged: to: self.! !

!CSBrowser methodsFor: 'autotdd - test runner dependence' stamp: 'rkrk 9/22/2009 03:21'!
testRunner

	^ CSTestRunner currentAutoTestRunner! !

!CSBrowser methodsFor: 'autotdd - test runner dependence' stamp: 'rkrk 9/30/2009 05:07'!
update: anAspect

	super update: anAspect.
	anAspect = #runnerClosed ifTrue: [
		"old runner is closed by user. Create a new one and register"
		self testRunner addDependent: self.
		^self].
	anAspect = #startTestRun ifTrue: [isRunning := true].
	anAspect = #endTestRun ifTrue: [isRunning := false].
	(#(newTestResult startTestRun endTestRun) includes: anAspect) ifFalse: [^ self].
	self announce: OBNodeChanged
	
	! !
CSTestRunner initialize!
CSTraceChooser initialize!
CSCoverageTracingWrapper initialize!
